(function ($, window) {
  "use strict";


  var loadDisigne = true; // add 18.04.2017
  var progress_bar_pointer = null,
      progress_bar_pointer_circle = null,
      circle_progressbar_text = null,
      status_progress_cancel = false,
      progress_value = "Searching...",
      progress_type = "Searching...",
      progress_status = "...in progress",
      old_notifications_count = null,
      notifi_loading_path = null,
      processing = false;

  function Linkelead() {
    alertify.set("notifier", "position", "top-right");
    /* Show or hide lists */
    function _showHideList($elem, $list, $item, action, event) {
      if ($elem.attr("id") == "fum-tmp" && self.dontSend) {
        // Not show list for follow-up template if "don't send"
        return;
      }

      $(".int-gr-body").each(function (k, v) {
        // Hide all lists except current list
        if (!$(v).find($list).length) {
          $(v).addClass("hidden");
        }
      });

      if ($list.parent().hasClass("hidden")) {
        $list.parent().removeClass("hidden");
      } else {
        $list.parent().addClass("hidden");
      }

      var $html = $("html");
      $html.off("click");
      $html.on("click", function (e) {
        // Clickout for list block
        if (action != "tag") {
          $list.parent().addClass("hidden");
        } else {
          // Not hide tag-list if click is inside tag-list
          if (
              !$(e.target).hasClass("add-tag-input") &&
              !$(e.target).hasClass("btn-add") &&
              !$(e.target).hasClass("tag-checkbox") &&
              !$(e.target).hasClass("tag-input")
          ) {
            $list.parent().addClass("hidden");
          }
        }
      });

      var $listItem;
      // Define list item
      if (action == "offer") {
        $listItem = $list.find("span");
      } else if (action == "connect") {
        $listItem = $list.find("span");
      } else if (action == "follow-up") {
        $listItem = $list.find("span");
      } else if (action == "inmail") {
        $listItem = $list.find("span");
      } else if (action == "tag") {
        $listItem = $list.find("li");
      }

      $listItem.off("click");
      if (action == "tag") {
        $("#add-tag-input").val("");
        $("#add-tag-input").css("border-color", "rgb(184, 184, 184)");
        $("#add-tag-input").off("keyup change paste");
        $("#add-tag-input").on("keyup change paste", function () {
          $(this).css("border-color", "rgb(184, 184, 184)");
        });
        $(".btn-add").off("click");
      }

      $listItem.on("click", function (e) {
        // Listener for list-item click
        if (action == "connect") {
          $("#somemessage").css("border-color", "rgb(184, 184, 184)");
          $("#somemessage").val(
              self.userData.settings.templates.ci[
                  parseInt($(this).attr("data-id"))
                  ].b
          );
          self.textLength = $("#somemessage").val().length;
          $(".txt-length").text("Text length: " + self.textLength + "/300");

          if (self.textLength > 300) {
            $("#somemessage").css("border-color", "red");
            alertify.notify("Max length: 300 symbols.", "error", 5);
          }
        } else if (action == "offer") {
          $("#subject").css("border-color", "rgb(184, 184, 184)");
          $("#somemessage3").css("border-color", "rgb(184, 184, 184)");
          $("#subject").val($(this).text());
          $("#somemessage3").val(
              self.userData.settings.templates.co[
                  parseInt($(this).attr("data-id"))
                  ].b
          );
        } else if (action == "follow-up") {
          $("#subject").css("border-color", "rgb(184, 184, 184)");
          $("#somemessage2").css("border-color", "rgb(184, 184, 184)");
          $("#subject").val($(this).text());
          $("#somemessage2").val(
              self.userData.settings.templates.fum[
                  parseInt($(this).attr("data-id"))
                  ].b
          );
        }
      });
      event.stopPropagation();
    }

    /* Add items to lists */
    function _addItems(type, prefix, $elem, data, itemIndex, valueIndex) {
      // if (data.length) {
      $("#e9").select2();
      $("#e9").bind("change", show_remove_ico);
      for (var i = 0; i < data.length; i++) {
        var $item, index, value, message;

        // Check for item index. It can be loading all items from list or adding only one item for tag-list
        if (itemIndex) {
          index = itemIndex;
        } else {
          index = i;
        }
        // Check for value index. It can be loading all items from list or adding only one item for tag-list
        if (valueIndex) {
          value = data[valueIndex];
        } else {
          value = data[i];
        }

        if (type == "tmp") {
          // Adding templates to list
          $item = self.tmpItem.clone();
          message = value.b;
          value = value.s;
          $item.html(
              '<div class="ll-ext-template-name">' +
              value +
              '</div><div class="ll-ext-template-preview">' +
              message +
              '</div><div class="ll-ext-template-use"><span>use</span></div>'
          );
          $item.attr("id", prefix + "-" + index);
          $item.attr("data-id", index);
        } else if (type == "tag") {
          // Adding tags to list
          $item = self.tagItem.clone();
          $item.text(value);
          $item.attr("value", index);
        }
        // $("#e9").select2();
        // $("#e9").bind("change", show_remove_ico);

        $elem.prepend($item);
      }
      // } else { // Show message if list is empty
      //     $item = $(self.html.noData);
      //     $elem.append($item);
      // }
    }

    function show_remove_ico() {
      var images_url = chrome.extension.getURL("images/");
      $(
          ".ll-ext-popup .ll-ext-tags-wrapper .select2-search-choice .select2-search-choice-close "
      ).css(
          "background",
          "url('" + images_url + "cross.svg')  no-repeat 0 0/100% 100%"
      );
    }

    var self = this;

    this.html = new HTML();

    this.userData = {};
    this.dateExpired = false;
    this.addPopupMsgListener = false;
    this.action = null;

    this.tmpItem = $(self.html.tmpItem);
    this.tagItem = $(self.html.tagItem);
    this.noData = $(self.html.noData);
    this.circleText = self.html.circleText;

    this.textLength = 0;
    this.dontSend = false;
    //this.inMailCredits;
    this.addBtnAfterLoad = false;
    this.design = 1;

    var visitMousUp = false,
        connectMousUp = false,
        inMailMousUp = false;

    this.saveCounteClick = function () {
      self.sendMessageToBG(
          {
            action: "saveCountClickSailse"
          },
          function (data) {
            console.log('saveCounteClick callback', data);
          }
      );
    };

    /* Check for "sales navigator" location */
    this.checkLocation = function () {
      //if (window.location.href.indexOf('linkedin.com/sales/') !== -1 ) {
      // Add button-wrap if there is "sales navigator search page" and userData is not empty
      if (
          window.location.href.indexOf("linkedin.com/sales/search") !== -1 &&
          !$.isEmptyObject(self.userData) &&
          !self.dateExpired
      ) {

        self.addButtonWrap();
      } else if (
          window.location.href.indexOf("linkedin.com/sales/search/results/index") !==
          -1 ||
          window.location.href.indexOf("linkedin.com/sales/search/results/people") !==
          -1
      ) {
        console.log('checkLocation 2');
        self.addPanelLinkedInSearch();
      } else if (
          window.location.href.indexOf("linkedin.com/sales/search") !== -1 &&
          (self.dateExpired || $.isEmptyObject(self.userData))
      ) {
        console.log('checkLocation 3');
        return;
      }
      console.log('CHECK LINK FOR PROCESSING', document.location.href.indexOf("https://www.linkedin.com/sales/search"));
      if (document.location.href.indexOf("https://www.linkedin.com/sales/search") !== -1) {
        self.checkProcessing();
      }

      if (!self.addPopupMsgListener) {
        self.messageListener();
        self.addPopupMsgListener = true;
      }
      //}
    };

    /* Check information about user */
    this.checkUser = function () {
      console.log('checkUser');
      self.sendMessageToBG({action: "session", login: false}, function (user) {
        console.log('checkUser callback', user);
        if (!user || user.err) {
          alertify.notify(
              "Connection error. Please try again in a few minutes.",
              "error",
              5
          );
          if (!self.addPopupMsgListener) {
            self.messageListener();
            self.addPopupMsgListener = true;
          }

          return;
        } else if (!$.isEmptyObject(user)) {
          // Check for user subscription or expiration date
          if (
              user.expirationDate > new Date().getTime() / 1000 ||
              user.promoCode > new Date().getTime() / 1000
          ) {
            self.userData = user;
          } else {
            self.userData = user;
            self.dateExpired = true;
            self.addPaymentWrap();
          }
        }
        //
        console.log('checkLocation');
        self.checkLocationInterval = setInterval(function () {
          self.checkLocation();
        }, 1000);
      });
    };

    /* Check for processing status */
    this.checkProcessing = function () {
      try {
        console.log('processingStatus 1');
        self.sendMessageToBG({action: "processingStatus"}, function (
            response
        ) {
          console.log('checkProcessing callback', response);
          if (response) {
            if (!response.processing) {
              // There is no processing

              if (!self.addBtnAfterLoad) {
                var checkForRefresh = false;

                if (
                    response.progressInfo.action == "refresh" &&
                    (response.progressInfo.counter == "Searching..." ||
                        response.progressInfo.counter == 0)
                ) {
                  checkForRefresh = true;
                  $("#processing").text("Please, open the main menu...");
                } else {
                  $("#processing").text("Please, wait...");
                }

                if (!checkForRefresh) {
                  self.addButton();
                } else {
                  // destroys progressbar
                  if (progress_bar_pointer && progress_bar_pointer.destroy) {
                    progress_bar_pointer.destroy();
                    progress_bar_pointer = null;
                    progress_bar_pointer_circle = null;
                    circle_progressbar_text = null;
                  }

                  var btn;
                  if (self.design == 1) {
                    btn = $(".ext-btn");
                  } else {
                    btn = $(".ext-btn-2");
                  }

                  //                                    $(btn).hide();
                  $("#processing").show();
                  $(".ext-progress-bar").remove();
                }
                self.checkForNotification(response);
              }

              if (
                  response.progressInfo.action == null &&
                  self.processing &&
                  !status_progress_cancel
              ) {
                if (progress_bar_pointer && progress_bar_pointer.destroy) {
                  progress_bar_pointer.destroy();
                  progress_bar_pointer = null;
                  progress_bar_pointer_circle = null;
                  circle_progressbar_text = null;
                }
                $(
                    "#notification-popup #notification_new_list .ll-ext-notification"
                ).attr("data-status", "cancelled");
                $(
                    "#notification-popup #notification_new_list .notification-text #progress_status"
                ).text("Cancelled");
                $(
                    "#notification-popup #notification_new_list .notification-text a"
                ).remove();
                self.notifications = {
                  progress_value: progress_value,
                  progress_type: progress_type,
                  progress_status: "Cancelled"
                };
                self.saveNotifications();

                progress_value = "Searching...";
                progress_type = "Searching...";
                $("#no_processing").css("display", "block");
                $("#the_processing").css("display", "none");
              }
              self.processing = false;
              status_progress_cancel = false;
            } else {
              // There is some processing now
              $("#notification_empty_list").remove();
              self.processing = true;
              self.removeBtn(response.progressInfo);
            }
          }
        });
      } catch (err) {
        alertify.notify(
            "Cookies expires. Please reload any LinkedIn page.",
            "error",
            5
        );
        $(".results-header .ext-btn-wrap").remove();
        $(".results-header #visit-popup").remove();
        $(".results-header #connect-popup").remove();
        $(".results-header #message-popup").remove();
        $(".results-header #notification-popup").remove();
        clearInterval(self.checkLocationInterval);
      }
    };

    /* Check for notification after success ending of some processing */
    this.checkForNotification = function (response) {
      if (response.showNotification[0]) {
        var txt = {
          visit: {
            send: "Profiles visited.",
            noData: "No new contacts found."
          },
          connect: {
            send: "Connect invitations sent.",
            noData: "No new contacts found."
          },
          offer: {
            send: "Messages sent.",
            noData: "No new contacts found."
          },
          refresh: {
            send: "Connections refreshed.",
            noData: "No connections to refresh."
          },
          cancel: {
            send: "All invitation canceled.",
            noData: "No connections to cancel invitation."
          }
        };

        if (response.showNotification[1] != 0) {
          $(
              "#notification-popup #notification_new_list .ll-ext-notification"
          ).attr("data-status", "done");
          $(
              "#notification-popup #notification_new_list .notification-text #progress_status"
          ).text("Done");
          // alertify.notify(txt[response.progressInfo.action].send, 'success', 5);
        } else {
          $(
              "#notification-popup .scrollbar-inner #notification_new_list .notification-number"
          ).text("");
          $(
              "#notification-popup .scrollbar-inner #notification_new_list #progress_text"
          ).text(txt[response.progressInfo.action].noData);
          $(
              "#notification-popup .scrollbar-inner #notification_new_list #progress_status"
          ).text("");
          $(
              "#notification-popup .scrollbar-inner #notification_new_list .notification-text a"
          ).remove();
          $("#no_processing").css("display", "block");
          $("#the_processing").css("display", "none");
          chrome.storage.local.remove("state");
          alertify.notify(
              txt[response.progressInfo.action].noData,
              "success",
              5
          );
          self.addButton();
        }
      }
      /*
       if (response.showErrorNotification) {
       alertify.notify(response.showErrorNotification, 'error', 5);
       }
       */
    };

    /* Remove button if there is some processing */
    this.removeBtn = function (progressInfo) {
      // console.log(progressInfo.action, progressInfo.counter);
      if (progressInfo.counter != 0 && progressInfo.counter != "") {
        $("#the_processing").css("display", "block");
        $("#no_processing").css("display", "none");
      }
      if (
          !(
              progressInfo.action == "refresh" &&
              progressInfo.counter == "Searching..."
          )
      ) {
        $("#processing").text("Please, wait...");
        //if (document.location.href.indexOf('linkedin.com/sales/') != -1) {
        self.addProgressBar(progressInfo);
        //}
      } else {
        $("#processing").text("Please, open the main menu...");
      }

      var extBtn;
      if ($(".status-bar").length > 0) {
        extBtn = $(".ext-btn-2");
      } else {
        extBtn = $(".ext-btn");
      }

      if (extBtn.css("display") == "block") {
//                extBtn.hide();
        $("#processing").show();
      }
    };

    /* Add processing progress-bar if there is some processing */
    this.addProgressBar = function (progressInfo) {
      var progress_bar_data = $("#notification-popup .ll-ext-notification"),
          _this = this;

      if (!$(".ext-progress-bar").length) {
        var title = "",
            body = "";
        $("html").append($(self.html.progressBar));

        var txt = {
          visit: {
            title: "Visiting profiles",
            body: "Please wait. \nVisiting is in process..."
          },
          connect: {
            title: "Sending connections",
            body: "Please wait...\nSending is in process..."
          },
          offer: {
            title: "Sending messages",
            body: "Please wait.\nSending is in process..."
          },
          refresh: {
            title: "Refreshing connects",
            body: "Please wait.\nRefreshing is in process..."
          },
          cancel: {
            title: "Canceling invitations",
            body: "Please wait.\nCanceling is in process..."
          }
        };

        $(".progress-bar-title").text(txt[progressInfo.action].title);
        $(".progress-bar-body").text(txt[progressInfo.action].body);
      } else {
        var percentage = 0;
        var SendStopToBG = function () {
          status_progress_cancel = true;
          chrome.storage.local.remove("state");
          console.log('stop_progress');
          self.sendMessageToBG(
              {action: "stop_progress", type: progressInfo.action},
              function (s) {
                console.log('SendStopToBG callback', s);
              }
          );
        };

        var progress_type_count;
        if (progressInfo.action == "visit") {
          progress_type = "Visiting Profiles";
          progress_type_count = self.userData.settings.visits_count;
        } else if (progressInfo.action == "connect") {
          progress_type = "Sending Connection Invitations";
          progress_type_count = self.userData.settings.users;
          console.log(progress_type_count);
        } else if (progressInfo.action == "offer") {
          progress_type = "Sending InMails";
          progress_type_count = self.userData.settings.inmails_count;
        }
        if (
            progress_type_count &&
            $("#notification-popup #notification_new_list .notification-number")
                .text()
                .trim() == ""
        ) {
          $(
              "#notification-popup .scrollbar-inner #notification_new_list"
          ).prepend(
              '<div class="ll-ext-notification new" data-status="search_progress"> ' +
              '<div class="notification-number">0/' +
              progress_type_count +
              "</div> " +
              '<div class="notification-text"><text id="progress_text">' +
              progress_type +
              '</text> <span id="progress_status">Starting...</span></div> ' +
              "</div> "
          );
        }

        if (progressInfo.counter != progress_value) {
          progress_bar_data.data("step", "progress");
          //console.log(progressInfo);

          var lim = -1;
          switch (progressInfo.action) {
            case "offer":
              lim = $("#message-popup input.decimal").val();
              break;
            case "connect":
              lim = $("#connect-popup input.decimal").val();
              break;
            case "visit":
              lim = $("#visit-popup input.decimal").val();
              break;
            default:
              lim = -1;
          }

          if (lim > -1) {
            progress_value = progressInfo.counter + "/" + lim;
            percentage = Math.floor(progressInfo.counter / lim * 1000);
          } else {
            progress_value = progressInfo.counter + "/" + progressInfo.limit;
            percentage = Math.floor(
                progressInfo.counter / progressInfo.limit * 1000
            );
          }

          /*
           if (progressInfo.action === "offer"){
           var lim =  $("#message-popup input.decimal").val();
           progress_value = progressInfo.counter + '/' + lim;
           percentage = Math.floor(progressInfo.counter / lim * 1000);
           }else if(progressInfo.action === "connect"){
           var lim =  $("#connect-popup input.decimal").val();
           progress_value = progressInfo.counter + '/' + lim;
           percentage = Math.floor(progressInfo.counter / lim * 1000);
           }else if (progressInfo.action === "visit"){
           var lim = $("#visit-popup input.decimal").val()
           progress_value = progressInfo.counter + '/' + lim;
           percentage = Math.floor(progressInfo.counter / lim * 1000);
           }else{
           progress_value = progressInfo.counter + '/' + progressInfo.limit;
           percentage = Math.floor(progressInfo.counter / progressInfo.limit * 1000);
           }
           */

          if (
              !$("#notification-popup .ll-ext-notification").hasClass(
                  "in_progress"
              )
          ) {
            $("#notification-popup .ll-ext-notification").addClass(
                "in_progress"
            );
            var _circle_progress_wrapper = $(
                "#notification-popup .ll-ext-notification"
            ).eq(0);

            if (
                _circle_progress_wrapper &&
                _circle_progress_wrapper.length &&
                _circle_progress_wrapper[0]
            ) {
              _circle_progress_wrapper = _circle_progress_wrapper[0];
              try {
                progress_bar_pointer = new ProgressBar.Circle(
                    _circle_progress_wrapper,
                    {
                      step: function (state, circle) {
                        if (!progress_bar_pointer_circle) {
                          progress_bar_pointer_circle = true;
                          if (
                              $(
                                  "#notification-popup #notification_new_list .notification-number"
                              )
                                  .text()
                                  .trim() != ""
                          ) {
                            $(
                                "#notification-popup #notification_new_list .notification-number"
                            ).text(progress_value);
                            $(
                                "#notification-popup #notification_new_list .notification-text #progress_text"
                            ).text(progress_type);
                            $(
                                "#notification-popup #notification_new_list .ll-ext-notification.new "
                            ).attr("data-status", "progress");
                            $(
                                "#notification-popup #notification_new_list .notification-text #progress_status"
                            ).text("...in progress");
                            $(
                                "#notification-popup #notification_new_list .notification-text"
                            ).append(
                                '<a href="#" class="progress-cancel">Cancel</a>'
                            );
                          }
                          progress_bar_pointer_circle = $(
                              "#notification-popup #notification_new_list .ll-ext-notification"
                          ).find(".notification-number");
                        }
                      }
                    }
                );
              } catch (err) {
              }
            }
          }

          if (progress_bar_pointer) {
            progress_bar_pointer.stop();
            if (progress_bar_pointer_circle) {
              progress_bar_pointer_circle.html(progress_value);
              if (!circle_progressbar_text) {
                circle_progressbar_text = $(
                    "#notification-popup .ll-ext-notification .notification-text .progress-cancel"
                );
                circle_progressbar_text.on("click", SendStopToBG);
              }
            }
          }
        }
      }
    };

    /* Add extension content-button */
    this.addButton = function () {
      var extBtn;

      if ($(".status-bar").length > 0) {
        extBtn = $(".ext-btn-2");
      } else {
        extBtn = $(".ext-btn");
      }

      if (extBtn.css("display") == "none") {
        extBtn.show();
      }

      // destroys progressbar
      if (progress_bar_pointer && progress_bar_pointer.destroy) {
        progress_bar_pointer.destroy();
        progress_bar_pointer = null;
        progress_bar_pointer_circle = null;
        circle_progressbar_text = null;
        if (!status_progress_cancel) {
          progress_status = "Done";
        } else {
          progress_status = "Cancelled";
        }
        $(
            "#notification-popup #notification_new_list .ll-ext-notification"
        ).attr("data-status", progress_status.toLowerCase());
        $(
            "#notification-popup #notification_new_list .notification-text #progress_status"
        ).text(progress_status);
        $(
            "#notification-popup #notification_new_list .notification-text a"
        ).remove();
        if (progress_type == "Visiting Profiles") {
          progress_type = "Visited Profiles";
        } else if (progress_type == "Sending Connection Invitations") {
          progress_type = "Connection Invitations Sent";
        } else if (progress_type == "Sending InMails") {
          progress_type = "Sent InMails";
        }
        $(
            "#notification-popup #notification_new_list .notification-text #progress_text"
        ).text(progress_type);
        self.notifications = {
          progress_value: progress_value,
          progress_type: progress_type,
          progress_status: progress_status
        };
        self.saveNotifications();

        progress_value = "Searching...";
        progress_type = "Searching...";
        $("#no_processing").css("display", "block");
        $("#the_processing").css("display", "none");
      } else if (self.processing) {
        self.processing = false;
        progress_status = "Cancelled";
        $(
            "#notification-popup #notification_new_list .ll-ext-notification"
        ).attr("data-status", "cancelled");
        $(
            "#notification-popup #notification_new_list .notification-text #progress_status"
        ).text("Cancelled");
        $(
            "#notification-popup #notification_new_list .notification-text a"
        ).remove();
        $("#no_processing").css("display", "block");
        $("#the_processing").css("display", "none");
      }
    };

    /* Add extension button-wrap */
    this.addButtonWrap = function () {
      var _this = this;
      // console.log("checkLocation");
      if (!$(".ext-btn-wrap").length) {
        self.checkDesign();

        loadDisigne = false; // add 18.04.2017
        // inc url add 18.04.2017
        chrome.runtime.sendMessage({action: "errorTest"}, function (response) {
          console.log('addButtonWrap', response);
          //callback(response);
        });
        $(".search-results").prepend($(self.html.btnWarp2));
        var images_url = chrome.extension.getURL("images/");
        notifi_loading_path = images_url;

        $(
            ".select2-container-multi .select2-choices .select2-search-field input.select2-active"
        ).css(
            "background",
            "#fff url('" +
            images_url +
            "select2-spinner.gif') no-repeat 100% !important;"
        );
        $(".select2-search-choice-close").css(
            "background",
            "url('" + images_url + "select2.png') right top no-repeat !important;"
        );
        $(".connect-btn").on("click", function () {
          chrome.runtime.sendMessage({action: "goCrm"});
        });

        self.btnWrapEvents();
        self.getInMailCredits();
      }
    };

    this.addPaymentWrap = function () {
      var _this = this;
      // console.log("checkLocation");
      if (!$(".ext-btn-wrap").length) {
        self.checkDesign();
        $(".search-results").prepend($(self.html.addPaymentWrap));
        var images_url = chrome.extension.getURL("images/");
        notifi_loading_path = images_url;
        $(".chose-plan-btn").on("click", function () {
          chrome.runtime.sendMessage({action: "goCrm"});
        });
      }
    };

    /* Content-button event listeners */
    this.btnWrapEvents = function () {
      var $btn = $(".ext-btn"),
          $list = $(".ext-btn-list2"),
          $listItem = $(".ext-list-item2");

      if (self.design == 2) {
        $btn = $(".ext-btn-wrap .primary-action-btn").eq(0);
      }

      $btn.on("click", function (e) {
        // Show or hide button-list
        var _$this = $(this);

        if ($list.css("display") == "none") {
          _$this.attr("data-is-animating-click", "true");

          $list.show();
        } else {
          _$this.removeAttr("data-is-animating-click");

//                    $list.hide();
        }

        $("html").one("click", function () {
          _$this.removeAttr("data-is-animating-click");

          $list.hide();
        });
        e.stopPropagation();
      });

      var showPopupReplace = function (popup, elem) {
        if (elem.hasClass('active')) {
          hidePopup(popup);
        } else {
          showPopup(popup, elem);
        }
      };


      $listItem.on("click", function () {
        // Show chosen popup
        $('.ll-ext-btn-list [data-popup]').removeClass('active');
        if ($(this).attr('data-popup') !== '') {
          var $popup = $('#' + $(this).attr('data-popup'));
          showPopupReplace($popup, $(this));
        }
        if ($(this).attr("data-id") == "vp") {
          self.action = "visitPage";
          self.visitPagePopup();
        } else if ($(this).attr("data-id") == "ci") {
          self.action = "connectInvitation";
          self.connectInvitationPopup();
        } else if ($(this).attr("data-id") == "co") {
          self.action = "consultingOffer";
          self.consultingOfferPopup();
        } else if ($(this).attr("data-id") == "no") {
          self.action = "notificationPage";
          self.notificationPagePopup();
        } else if ($(this).attr("data-id") == "in") {
          self.action = "inmailSend";
          self.consultingOfferPopup();
        }
      });

      $(document).on("slider-change", function (e, data) {
        self.userData.settings[data.settingName] = data.value;
        self.saveChanges();
      });

      $(window).on("click", function (e) {
        if (
            e.target.ownerDocument &&
            e.target.ownerDocument.activeElement &&
            e.target.ownerDocument.activeElement.className.indexOf("slider") != -1
        ) {
          return false;
        }
        var popupId = $(e.target).data("id")
            ? "#" + $(e.target).data("popup")
            : $(e.target).parents(".ext-btn").length
                ? "#" + $(e.target).parents(".ext-btn").data("popup")
                : "";
        if (
            !$(e.target).hasClass("active") &&
            !$(e.target).parents(".ll-ext-popup.active").length &&
            (!popupId || !$(popupId).hasClass("active"))
        ) {
          $(".ll-ext-popup.active").removeClass("active");
          if (!popupId) {
            $(".ext-btn").removeClass("active");
          }
        }
      });

      $(document).on("change", ".ll-ext-popup .decimal", function (e) {
        var slider = $(this)
            .parents(".ll-ext-popup")
            .find(".ll-ext-popup-slider");
        slider.attr("data-val", $(this).val());
        var settingName = slider.data("setting-name");
        self.userData.settings[settingName] = $(this).val();
        self.saveChanges();
      });
    };

    /* Popup for visiting pages */
    this.visitPagePopup = function (event) {
      var $btn = $(".ext-btn");

      if (self.design == 2)
        $btn = $(".ext-btn-wrap .primary-action-btn").eq(0);

//            $btn.hide();
      $("#processing").show();
      self.addBtnAfterLoad = true;
      console.log('visitPagePopup');

      self.sendMessageToBG({action: "getSettings"}, function (response) {
        console.log('visitPagePopup getSettings callback', response);
        if (response.err) {
          alertify.notify(
              "Connection error. Please try again in a few minutes.",
              "error",
              5
          );
          $btn.show();
          $("#processing").hide();
          self.visitPopupEvents();

          return;
        }

        if (!$.isEmptyObject(response) && response.status != "Not subscribed") {
          console.log($(self.html.visitPopup));
          $("html").append($(self.html.visitPopup));
          $(".header-title").text("Visit profiles");

          $(".count-title").text(
              "Of " + response.settings.users + " users from the search results"
          );
          $("#visit-popup .ll-ext-popup-slider-val").text(
              response.settings.visits_count
          );
          $("#visit-popup .ll-ext-popup-slider")
              .slider("value", response.settings.visits_count)
              .attr("data-val", response.settings.visits_count);
          $("#visit-popup .ui-slider-handle").fadeIn();
          $("#visit-popup .decimal").val(response.settings.visits_count);

          self.visitPopupEvents();
          $btn.show();
          $("#processing").hide();
          self.addBtnAfterLoad = false;
        } else if ($.isEmptyObject(response)) {
          self.userData = {};
          $(".ext-modal").remove();
          $(".ext-btn-wrap").remove();
          alertify.notify(
              "Cookies expires. Please reload any LinkedIn page.",
              "error",
              5
          );
        } else {
          if (response.expirationDate < new Date().getTime() / 1000) {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your subscription has expired.', 'error', 5);
          } else {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your promo code has expired.', 'error', 5);
          }
        }
      });
    };

    this.connectInvitationPopup = function (event) {
      var $btn = $(".ext-btn");

      if (self.design == 2)
        $btn = $(".ext-btn-wrap .primary-action-btn").eq(0);
//            $btn.hide();
      $("#processing").show();
      self.addBtnAfterLoad = true;
      console.log('connectInvitationPopup');
      self.sendMessageToBG({action: "getSettings"}, function (response) {
        console.log('connectInvitationPopup', response);
        if (response.err) {
          alertify.notify(
              "Connection error. Please try again in a few minutes.",
              "error",
              5
          );
          $btn.show();
          $("#processing").hide();
          self.connectPopupEvents();

          return;
        }
        if (!$.isEmptyObject(response) && response.status != "Not subscribed") {
          self.userData = response;
          $("html").append($(self.html.sendConnects));
          $(".header-title").text("Send Connect Invitations");
          $(".count-title").text(
              "To " + response.settings.users + " users from the search results"
          );

          $("#connect-popup .ll-ext-popup-slider-val").text(
              response.settings.users
          );
          $("#connect-popup .ll-ext-popup-slider")
              .slider("value", response.settings.users)
              .attr("data-val", response.settings.users);
          $("#connect-popup .ui-slider-handle").fadeIn();
          $("#connect-popup .decimal").val(response.settings.users);

          // Clear lists
          $("#connect-tmp-list").html();
          $("#fum-tmp-list").html();
          $(".checkbox-items").html();

          // Add templates and tags to lists
          $("#connect-tmp-list").empty();
          $("#fum-tmp-list").empty();
          $("#e9").empty();
          //console.log(extension.getURL);

          _addItems(
              "tmp",
              "ci",
              $("#connect-tmp-list"),
              response.settings.templates.ci,
              null,
              null
          );
          _addItems(
              "tmp",
              "fum",
              $("#fum-tmp-list"),
              response.settings.templates.fum,
              null,
              null
          );
          _addItems("tag", "tag", $("#e9"), response.settings.tags, null, null);
          console.log(response.settings.tags);
          console.log(response.settings.templates);

          $(
              "#connect-tmp-list .ll-ext-template-item .ll-ext-template-use"
          ).on("click", function () {
            console.log("test1");
            $("#somemessage").empty();
            $("#somemessage").val(
                response.settings.templates.ci[$(this).parent().data("id")].b
            );
            var tabs = $("#new_message").closest(".ll-ext-tabs-wrapper");
            tabs
                .find(".ll-ext-tabs-labels a:eq(0)")
                .addClass("active")
                .siblings("a")
                .removeClass("active");
            tabs
                .find(".ll-ext-tabs-content:eq(0)")
                .addClass("active")
                .siblings(".ll-ext-tabs-content")
                .removeClass("active");
            tabs
                .find(".ll-ext-tabs-content:eq(0) .scrollbar-inner")
                .scrollbar();
          });

          $(
              "#fum-tmp-list .ll-ext-template-item .ll-ext-template-use"
          ).on("click", function () {
            console.log("test1");
            $("#somemessage2").empty();
            $("#somemessage2").val(
                response.settings.templates.fum[$(this).parent().data("id")].b
            );
            $("#somemessage2").attr(
                "data-subject",
                response.settings.templates.fum[$(this).parent().data("id")].s
            );
            var tabs = $("#new_followUp").closest(".ll-ext-tabs-wrapper");
            tabs
                .find(".ll-ext-tabs-labels a:eq(0)")
                .addClass("active")
                .siblings("a")
                .removeClass("active");
            tabs
                .find(".ll-ext-tabs-content:eq(0)")
                .addClass("active")
                .siblings(".ll-ext-tabs-content")
                .removeClass("active");
            tabs
                .find(".ll-ext-tabs-content:eq(0) .scrollbar-inner")
                .scrollbar();
          });

          $("body").on("keyup", ".select2-input", function (e) {
            // Add new tag inside tag-list
            console.log("test");
            var $tagInput = $(".select2-input"),
                findSameTag = false;
            if (
                $tagInput.val().trim() != "" &&
                !$.isEmptyObject(self.userData.settings)
            ) {
              if ($("#e9").find(".no-data").length) {
                // Show message about no tags
                $("#e9").find(".no-data").remove();
              }

              for (var i = 0; i < self.userData.settings.tags.length; i++) {
                // Check for tag with the same name
                if ($tagInput.val() == self.userData.settings.tags[i]) {
                  findSameTag = true;
                }
              }

              if (!findSameTag) {
                $(".select2-no-results").text("Press enter for add new tag");
                $(".select2-no-results").css("overflow-y", "hidden");
                if (e.keyCode == 13) {
                  var this_tag = $tagInput.val();
                  _addItems(
                      "tag",
                      "tag",
                      $("#e9"),
                      [$tagInput.val()],
                      self.userData.settings.tags.length,
                      0
                  );
                  self.userData.settings.tags.push(this_tag);
                  self.saveChanges();
                  var selected_values = [];
                  var new_tag_id = $("#e9 option:first").val();
                  if (!$("#e9").val()) {
                    selected_values[0] = new_tag_id;
                  } else {
                    selected_values = $("#e9").val();
                    selected_values[selected_values.length] = new_tag_id;
                  }
                  console.log(123);
                  $("#e9").val(selected_values).trigger("change");
                }
              }
            }
          });

          self.textLength = 0;
          self.dontSend = false;
          self.connectPopupEvents();

          $btn.show();
          $("#processing").hide();
          self.addBtnAfterLoad = false;
        } else if ($.isEmptyObject(response)) {
          self.userData = {};
          $(".ext-modal").remove();
          $(".ext-btn-wrap").remove();
          alertify.notify(
              "Cookies expires. Please reload any LinkedIn page.",
              "error",
              5
          );
        } else {
          if (response.expirationDate < new Date().getTime() / 1000) {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your subscription has expired.', 'error', 5);
          } else {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your promo code has expired.', 'error', 5);
          }
        }
      });
    };

    /* Popup for consulting offers */
    this.consultingOfferPopup = function (event) {
      var $btn = $(".ext-btn");

      if (self.design == 2)
        $btn = $(".ext-btn-wrap .primary-action-btn").eq(0);

//            $btn.hide();
      $("#processing").show();
      self.addBtnAfterLoad = true;
      console.log('consultingOfferPopup');
      self.sendMessageToBG({action: "getSettings"}, function (response) {
        console.log('consultingOfferPopup getSettings callback', response);

        if (response.err) {
          alertify.notify(
              "Connection error. Please try again in a few minutes.",
              "error",
              5
          );
          $btn.show();
          $("#processing").hide();
          self.OfferPopupEvents();

          return;
        }

        if ($.isEmptyObject(response)) {
          self.userData = {};
          $(".ext-modal").remove();
          $(".ext-btn-wrap").remove();
          alertify.notify(
              "Cookies expires. Please reload any LinkedIn page.",
              "error",
              5
          );

          return;
        } else if (
            !$.isEmptyObject(response) &&
            response.status != "Not subscribed"
        ) {

          if (true) {
            console.log('asdasdasd');
            self.sendMessageToBG(
                {
                  action: "getInMailCredits",
                  url: document.location.href.replace(/#/g, "")
                },
                function (inMailCredits) {
                  console.log('consultingOfferPopup getInMailCredits callback');


                  var currentCount = response.settings.inmails_count;
                  var maxExceed = false;
                  if (currentCount > self.inMailCredits) {
                    maxExceed = true;
                    currentCount = self.inMailCredits;
                  }

                  $("#countinmail").text(
                      "You have " +
                      (typeof inMailCredits === "number" ? inMailCredits : "") +
                      " InMail"
                  );
                  $("#message-popup .ll-ext-popup-slider-val").text(1);
                  $("#message-popup .ll-ext-popup-slider-max").text(500); // ### 1000 -> 500
                  $("#message-popup .ll-ext-popup-slider")
                      .slider({value: 1, max: 500})
                      .attr("data-val", 1);
                  $("#message-popup .ll-ext-popup-treat input").attr(
                      "data-max",
                      500
                  );
                  $("#message-popup .ui-slider-handle").fadeIn();
                  $("#message-popup .decimal").val(1);
                  self.userData = response;
                  if (maxExceed) {
                    console.log("chnaged ");
                    $("#message-popup .ll-ext-popup-treat input").change();
                  }

                  $("html").append($(self.html.sendConsultingOffer));
                  $(".header-title").text("Send Consulting Offers");

                  if (response.status != "Not subscribed") {
                    $(".count-title").text(
                        "To " +
                        response.settings.users +
                        " users from the search results"
                    );
                  }

                  if (self.inMailCredits !== false) {
                    if (self.inMailCredits == 0) {
                      $(".inMailCredits").css("color", "red");
                      $(".inMailCredits").text(
                          "You have no InMail credits available"
                      );
                    } else {
                      $(".inMailCredits").css("color", "#000");
                      $(".inMailCredits").text(
                          "You have " +
                          self.inMailCredits +
                          " InMail credits available"
                      );
                    }
                  }

                  $("#offer-tmp-list").html(); // Clear template list
                  $("#offer-tmp-list").empty();

                  // Add templates to list
                  _addItems(
                      "tmp",
                      "tmp",
                      $("#offer-tmp-list"),
                      response.settings.templates.co,
                      null,
                      null
                  );

                  $(
                      "#offer-tmp-list .ll-ext-template-item .ll-ext-template-use"
                  ).on("click", function () {
                    $("#somemessage3").empty();
                    $("#somemessage3").val(
                        response.settings.templates.co[$(this).parent().data("id")].b
                    );
                    $("#subject_in").val(
                        response.settings.templates.co[$(this).parent().data("id")].s
                    );
                    console.log(response.settings.templates);
                    $("#somemessage3").attr(
                        "data-subject",
                        response.settings.templates.co[$(this).parent().data("id")].s
                    );
                    var tabs = $("#new_inmail_message").closest(
                        ".ll-ext-tabs-wrapper"
                    );
                    tabs
                        .find(".ll-ext-tabs-labels a:eq(0)")
                        .addClass("active")
                        .siblings("a")
                        .removeClass("active");
                    tabs
                        .find(".ll-ext-tabs-content:eq(0)")
                        .addClass("active")
                        .siblings(".ll-ext-tabs-content")
                        .removeClass("active");
                    tabs
                        .find(".ll-ext-tabs-content:eq(0) .scrollbar-inner")
                        .scrollbar();
                  });


                  self.OfferPopupEvents();

                  $btn.show();
                  $("#processing").hide();
                  self.addBtnAfterLoad = false;
                }
            );
          }
        } else {
          if (response.expirationDate < new Date().getTime() / 1000) {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your subscription has expired.', 'error', 5);
          } else {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your promo code has expired.', 'error', 5);
          }
        }
      });

    };

    /* Popup for notification pages */
    this.notificationPagePopup = function (event) {
      $("#processing").show();
      self.addBtnAfterLoad = true;
      console.log('notificationPagePopup');
      self.sendMessageToBG({action: "getSettings"}, function (response) {
        console.log('notificationPagePopup getSettings callback', response);
        if (response.err) {
          alertify.notify(
              "Connection error. Please try again in a few minutes.",
              "error",
              5
          );
          $btn.show();
          $("#processing").hide();
          self.visitPopupEvents();

          return;
        }

        if (!$.isEmptyObject(response) && response.status != "Not subscribed") {
          $("html").append($(self.html.visitPopup));
          console.log("response.notifications: ", response.notifications);

          notificationsList(response.notifications);
          $("#processing").hide();
          self.addBtnAfterLoad = false;
        } else if ($.isEmptyObject(response)) {
          self.userData = {};
          $(".ext-modal").remove();
          $(".ext-btn-wrap").remove();
          alertify.notify(
              "Cookies expires. Please reload any LinkedIn page.",
              "error",
              5
          );
        } else {
          if (response.expirationDate < new Date().getTime() / 1000) {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your subscription has expired.', 'error', 5);
          } else {
            self.userData = {};
            $(".ext-modal").remove();
            $(".ext-btn-wrap").remove();
            // alertify.notify('Your promo code has expired.', 'error', 5);
          }
        }
      });
    };

    function notificationsList(notifications) {
      console.log(123);
      if (notifications != "") {
        $("#notification-popup #notification_old_list").empty();

        //if there is a new notification, then remove 1 element from 4
        if ($("#notification_new_list .ll-ext-notification").length > 0) {
          var check_progress_status = $(
              "#notification_new_list #progress_status"
          ).text();
          if (
              self.processing ||
              check_progress_status == "Starting..." ||
              check_progress_status == "...in progress"
          ) {
            //there is some processing
            if (notifications.length > 3) {
              notifications.shift();
            }
          } else {
            //processing completed and notifications saved
            notifications.pop();
          }
        }
        for (var i = 0; i < notifications.length; i++) {
          $("#notification-popup #notification_old_list").prepend(
              '<div class="ll-ext-notification" data-status="' +
              notifications[i]["progress_status"].toLowerCase() +
              '"> ' +
              '<div class="notification-number">' +
              notifications[i]["progress_value"] +
              "</div> " +
              '<div class="notification-text"><text>' +
              notifications[i]["progress_type"] +
              "</text> <span>" +
              notifications[i]["progress_status"] +
              "</span>" +
              "</div> "
          );
        }
      } else {
        $("#notification-popup #notification_empty_list").remove();
        $("#notification-popup").append(
            '<div id="notification_empty_list"></div>'
        );
        $("#notification-popup #notification_empty_list").prepend(
            '<div class="ll-ext-notification" data-status=""> ' +
            '<div class="notification-text"><text>Doesn\'t have notifications</span>' +
            "</div> "
        );
      }
    }

    /* Visit-popup event listeners */
    this.visitPopupEvents = function () {
      console.log("hello");
      $("#visit-popup .send-btn").off("click");
      console.log("work  ?");

      var click = false;
      $("#visit-popup .send-btn").on("click", function () {
        if (!click) {
          click = true;
          console.log('visitPopupEvents');
          self.sendMessageToBG({action: "session", login: false}, function (
              user
          ) {
            console.log('visitPopupEvents callback', user);
            click = false;
            // self.countClickSails.visited++;
            self.saveCounteClick();
            if (user.err) {
              alertify.notify(
                  "Connection error. Please try again in a few minutes.",
                  "error",
                  5
              );

              return;
            } else if (!$.isEmptyObject(user)) {
              // Check for user subscription or expiration date
              if (
                  user.expirationDate > new Date().getTime() / 1000 ||
                  user.promoCode > new Date().getTime() / 1000
              ) {
                self.userData = user;
                //console.log(self.userData.settings.visits_count);
                $(
                    "#notification-popup .scrollbar-inner #notification_new_list"
                ).empty();
                old_notifications_count = 3;
                $(
                    "#notification-popup .scrollbar-inner #notification_new_list"
                ).prepend(
                    '<div class="ll-ext-notification new" data-status="search_progress"> ' +
                    '<div class="notification-number">0/' +
                    self.userData.settings.visits_count +
                    "</div> " +
                    '<div class="notification-text"><text id="progress_text">Visiting Profiles...</text> <span id="progress_status">Starting...</span></div> ' +
                    "</div> "
                );
                $("#visit-popup .cancel-btn span").click();

                self.visitPage(document.location.href.replace(/#/g, ""));
              } else {
                if (
                    user.expirationDate < new Date().getTime() / 1000 &&
                    user.expirationDate != 0
                ) {
                  self.userData = {};
                  $("#visit-popup .cancel-btn span").click();
                  // alertify.notify('Your subscription has expired.', 'error', 5);
                } else if (
                    user.promoCode < new Date().getTime() / 1000 &&
                    user.promoCode != 0
                ) {
                  self.userData = {};
                  $("#visit-popup .cancel-btn span").click();
                  // alertify.notify('Your promo code has expired.', 'error', 5);
                }
              }
            } else if ($.isEmptyObject(user)) {
              self.userData = {};
              $("#visit-popup .cancel-btn span").click();
              alertify.notify(
                  "Cookies expires. Please reload any LinkedIn page.",
                  "error",
                  5
              );
            }
          });
        }
      });
    };

    /* Connect-popup event listeners */
    this.connectPopupEvents = function () {
      $("#connect-popup .send-btn").off("click");
      $("#connect-popup .ll-ext-error").css("display", "none");
      $("#somemessage").on("keyup change paste", function () {
        var el = $(this);
        el.css("border-color", "rgb(184, 184, 184)");
        setTimeout(function () {
          self.textLength = el.val().length;
          $(".txt-length").text("Text length: " + self.textLength + "/300");
        }, 100);
      });

      var click = false;
      $("#connect-popup .send-btn").on("click", function (e) {
        if (!click) {
          click = true;
          //console.log('CLICK CLIKC CLIKC CLICK');
          // self.countClickSails.connect++;
          self.saveCounteClick();
          console.log('connectPopupEvents');
          self.sendMessageToBG({action: "session", login: false}, function (
              user
          ) {
            console.log('connectPopupEvents 2 callback', user);

            click = false;
            if (user.err) {
              alertify.notify(
                  "Connection error. Please try again in a few minutes.",
                  "error",
                  5
              );

              return;
            } else if (!$.isEmptyObject(user)) {
              console.log('connectPopupEvents 2')
              // Check for user subscription or expiration date
              if (
                  user.expirationDate > new Date().getTime() / 1000 ||
                  user.promoCode > new Date().getTime() / 1000
              ) {
                self.userData = user;

                if ($("#somemessage").val().trim() != "") {
                  // Message body is not empty
                  if (self.textLength > 300) {
                    $(this).css("border-color", "red");
                    // alertify.notify('Max length: 300 symbols.', 'error', 5);

                    return;
                  }

                  var ciObj = {},
                      tagsArr = [],
                      fumVal = $("#somemessage2").val().trim(),
                      fum = false,
                      tags = $(".select2-search-choice").find("div");

                  $(tags).each(function (index, value) {
                    // Form list of chosen tags
                    tagsArr.push($(value).html());
                  });

                  if (!tagsArr.length) {
                    tagsArr = false;
                  }

                  ciObj.b = $("#somemessage").val().trim();
                  ciObj.tagsList = tagsArr;

                  if (fumVal == "") {
                    // If "Follow Up Message" is true
                    ciObj.fum = false;
                  } else {
                    // If "Follow Up Message" is false
                    if ($("#somemessage2").attr("data-subject") != undefined) {
                      fum = $("#somemessage2").attr("data-subject");
                    }
                    ciObj.fum = {
                      s: fum,
                      b: fumVal
                    };
                  }
                  $(
                      "#notification-popup .scrollbar-inner #notification_new_list"
                  ).empty();
                  old_notifications_count = 3;
                  $(
                      "#notification-popup .scrollbar-inner #notification_new_list"
                  ).show().prepend(
                      '<div class="ll-ext-notification new" data-status="search_progress"> ' +
                      '<div class="notification-number">0/' +
                      self.userData.settings.users +
                      "</div> " +
                      '<div class="notification-text"><text id="progress_text">Sending Connection Invitations</text> <span id="progress_status">Starting...</span></div> ' +
                      "</div> "
                  );
                  $("#connect-popup .cancel-btn span").click();
                  $("#somemessage").val("");
                  $("#somemessage2").val("");
                  $("#no_processing").css("display", "none");
                  $("#the_processing").css("display", "block");

                  self.sendConnectInvitations(
                      document.location.href.replace(/#/g, ""),
                      ciObj
                  );
                } else {
                  // Message body is empty
                  $("#connect-popup .ll-ext-error").css("display", "block");
                  $("#somemessage").css("border-color", "red");
                  // alertify.notify('Empty message body.', 'error', 5);
                }
              } else {
                if (
                    user.expirationDate < new Date().getTime() / 1000 &&
                    user.expirationDate != 0
                ) {
                  self.userData = {};
                  $(".ext-modal").remove();
                  $(".ext-btn-wrap").remove();
                  // alertify.notify('Your subscription has expired.', 'error', 5);
                } else if (
                    user.promoCode < new Date().getTime() / 1000 &&
                    user.promoCode != 0
                ) {
                  self.userData = {};
                  $(".ext-modal").remove();
                  $(".ext-btn-wrap").remove();
                  // alertify.notify('Your promo code has expired.', 'error', 5);
                }
              }
            } else if ($.isEmptyObject(user)) {
              self.userData = {};
              $(".ext-modal").remove();
              $(".ext-btn-wrap").remove();
              alertify.notify(
                  "Cookies expires. Please reload any LinkedIn page.",
                  "error",
                  5
              );
            }
          });
        }
      });

      // Show or hide lists of templates
      $("#connect-tmp").on("click", function (e) {
        _showHideList(
            $(this),
            $("#connect-tmp-list"),
            $(".template-list").find("span"),
            "connect",
            e
        );
      });

      $("#tag-choose").on("click", function (e) {
        _showHideList(
            $(this),
            $(".checkbox-items"),
            $(".checkbox-items").find("label"),
            "tag",
            e
        );
      });

      $("#fum-tmp").on("click", function (e) {
        _showHideList(
            $(this),
            $("#fum-tmp-list"),
            $(".template-list").find("span"),
            "follow-up",
            e
        );
      });

      // Change "don't send" value
      $(".lg-right-check").on("click", function (e) {
        if (e.target.localName == "input" && e.target.checked) {
          self.dontSend = true;
          $("#subject").prop("disabled", true);
          $("#subject").css("background-color", "rgb(235, 235, 228)");
          $("#subject").css("border-color", "rgb(184, 184, 184)");
          $("#somemessage2").css("border-color", "rgb(184, 184, 184)");
          $("#somemessage2").attr("disabled", true);
        } else {
          self.dontSend = false;
          $("#subject").prop("disabled", false);
          $("#subject").css("background-color", "#ffffff");
          $("#somemessage2").attr("disabled", false);
        }
      });
    };

    /* Message-popup event listeners */
    this.OfferPopupEvents = function () {
      $("#message-popup .send-btn").off("click");
      $("#message-popup .ll-ext-error").css("display", "none");

      var click = false;
      $("#message-popup .send-btn").on("click", function () {
        if (!click) {
          click = true;
          //console.log(self.inMailCredits);
          // self.countClickSails.inMails++;
          self.saveCounteClick();
          console.log('OfferPopupEvents');
          self.sendMessageToBG({action: "session", login: false}, function (
              user
          ) {
            console.log('OfferPopupEvents 2 callback', user);
            click = false;
            if (user.err) {
              alertify.notify(
                  "Connection error. Please try again in a few minutes.",
                  "error",
                  5
              );

              return;
            } else if (!$.isEmptyObject(user)) {
              var subject = false;
              // Check for user subscription or expiration date
              if (
                  user.expirationDate > new Date().getTime() / 1000 ||
                  user.promoCode > new Date().getTime() / 1000
              ) {
                self.userData = user;
                // new code 10.04.2017 вернуть условие
                // self.inMailCredits > 0

                if (true) {
                  if (
                      $("#somemessage3").val().trim() != "" &&
                      $("#subject_in").val().trim() != ""
                  ) {
                    $(
                        "#notification-popup .scrollbar-inner #notification_new_list"
                    ).empty();
                    old_notifications_count = 3;
                    $(
                        "#notification-popup .scrollbar-inner #notification_new_list"
                    ).prepend(
                        '<div class="ll-ext-notification new" data-status="search_progress"> ' +
                        '<div class="notification-number">0/' +
                        self.userData.settings.inmails_count +
                        "</div> " +
                        '<div class="notification-text"><text id="progress_text">Sending InMails...</text> <span id="progress_status">Starting...</span></div> ' +
                        "</div> "
                    );
                    $("#message-popup .cancel-btn span").click();

                    if ($("#somemessage3").attr("data-subject") != undefined) {
                      subject = $("#somemessage3").attr("data-subject");
                    }
                    //console.log($('#subject_in').val());
                    self.sendConsultingOffers(
                        document.location.href.replace(/#/g, ""),
                        {
                          s: subject,
                          t: $("#subject_in").val(),
                          b: $("#somemessage3").val(),
                          c:
                              self.inMailCredits *
                              ($("#openLinkOnly").prop("checked") ? 0 : 1) // ### 0 : 1
                        }
                    );
                    $("#somemessage3").val("");
                    $("#subject_in").val("");
                  } else {
                    // Subject or body is empty
                    $("#message-popup .ll-ext-error").css("display", "block");
                  }
                } else {

                }
              } else {
                if (
                    user.expirationDate < new Date().getTime() / 1000 &&
                    user.expirationDate != 0
                ) {
                  self.userData = {};
                  $(".ext-modal").remove();
                  $(".ext-btn-wrap").remove();
                  // alertify.notify('Your subscription has expired.', 'error', 5);
                } else if (
                    user.promoCode < new Date().getTime() / 1000 &&
                    user.promoCode != 0
                ) {
                  self.userData = {};
                  $(".ext-modal").remove();
                  $(".ext-btn-wrap").remove();
                  // alertify.notify('Your promo code has expired.', 'error', 5);
                }
              }
            } else if ($.isEmptyObject(user)) {
              self.userData = {};
              $(".ext-modal").remove();
              $(".ext-btn-wrap").remove();
              alertify.notify(
                  "Cookies expires. Please reload any LinkedIn page.",
                  "error",
                  5
              );
            }
          });
        }
      });
    };

    /* Visit pages of chosen contacts */
    this.visitPage = function (searchUrl, options) {
      console.log('visitPage');
      self.sendMessageToBG(
          {
            action: "processing",
            type: "visit",
            searchUrl: searchUrl,
            options: null,
            design: self.design
          },
          function (s) {
            console.log('visitPage 2 callback', s);

          }
      );
    };

    /* Send connect invitation to chosen contacts */
    this.sendConnectInvitations = function (searchUrl, options) {
      //console.log("options:", options);
      console.log('sendConnectInvitations');

      self.sendMessageToBG(
          {
            action: "processing",
            type: "connect",
            searchUrl: searchUrl,
            options: options,
            design: self.design
          },
          function (cb) {
            console.log('sendConnectInvitations  callback', cb);
          }
      );
    };

    /* Send consulting offers to chosen contacts */
    this.sendConsultingOffers = function (searchUrl, options) {
      console.log('sendConsultingOffers');

      self.sendMessageToBG(
          {
            action: "processing",
            type: "offer",
            searchUrl: searchUrl,
            options: options,
            design: self.design
          },
          function (cb) {
            console.log('sendConsultingOffers callback', cb);
          }
      );
    };

    /* Get user name and profile image */
    this.getUserInfo = function (callback) {
      var $profileEl = $(".profile-photo"),
          photoSrc = $profileEl.attr("src"),
          userName = $profileEl.attr("alt");

      chrome.storage.local.set({
        userInfo: {
          photoSrc: photoSrc,
          userName: userName
        }
      });

      callback(photoSrc, userName);
    };

    /* Save changes for user settings */
    this.saveChanges = function () {
      console.log('saveChanges');

      self.sendMessageToBG(
          {action: "saveSettings", settings: self.userData.settings},
          function (cb) {
            console.log('saveChanges callback');
            // if (cb) {
            //     alertify.notify('Settings saved successfully!', 'success', 5);
            // }
          }
      );
    };

    /* Save changes for user notifications */
    this.saveNotifications = function () {
      console.log('saveNotifications');

      self.sendMessageToBG(
          {action: "saveNotifications", notifications: self.notifications},
          function (cb) {
            console.log('saveNotifications callback', cb);
          }
      );
    };

    /* Refresh user connects */
    this.refreshConnects = function () {
      console.log('refreshConnects');

      self.sendMessageToBG({action: "refresh"}, function (response) {
        console.log('refreshConnects callback', response);

        if (response) {
          if (response.showNotification[0]) {
            // alertify.notify('No new connects to refresh.', 'success', 5);
          }
        }
      });
    };

    /* Open linkedin page to parse "memberId" */
    this.reloadPage = function () {
      //setTimeout(function () {
      location.reload();
      //}, 2000);
    };

    /* Send message to background page */
    this.sendMessageToBG = function (options, callback) {
      console.log('sendMessageToBG content-new', options);
      callback = callback || function () {};

      chrome.runtime.sendMessage(options, function (response) {
        console.log('getMessage from BG2', response);
        callback(response);
      });
    };

    /* Message listener */
    this.messageListener = function () {
      console.log('messageListener start');
      chrome.runtime.onMessage.addListener(function (
          request,
          sender,
          sendResponse
      ) {
        console.log('messageListener', request);
        //console.log(request);
        if (request.action == "checkLocation") {
          self.getUserInfo(function (src, name) {
            sendResponse({resp: true, info: {src: src, name: name}});
          });
        } else if (request.action === "notificationRefresh") {
//                    self.NotificationRefresh();
        } else if (request.action == "reloadPage") {
          sendResponse({status: true});
          self.reloadPage();
        } else if (request.action == "saved") {
          sendResponse({status: true});
          // alertify.notify('Settings saved successfully!', 'success', 5);
        } else if (request.action == "refresh") {
          sendResponse(true);

          self.refreshConnects();
        } else if (request.action == "checkTruePageFromBG") {
          sendResponse(true);
        } else if (request.action == "showSystemNotification") {
          alertify.notify(request.message, "error", 5);
          sendResponse({msgResp: true});
        } else if (request.action == "showProcessingNotification") {
          console.log("REQUEST: ", request.data);

          self.checkForNotification(request.data);
          sendResponse(true);
        } else if (request.action == "mailto_event" && request.href) {
          sendResponse(true);
          window.location.href = "mailto:" + request.href;
        } else if (request.action == "showSuccessNotification") {
          sendResponse(true);
          alertify.notify(request.message, "success", 5);

          if (request.message == "Promo-code activated.") {
            setTimeout(function () {
              location.reload();
            }, 1000);
          }
        }
      });
    };

    this.checkDesign = function () {
      var _this = this;

      if ($(".status-bar").length > 0) {
        self.design = 2;
        console.log("set up secon version of design");
        //console.log("app error sory");
        // add 18.04.2017
        /*
         callback = callback || function () {

         };
         */
      }

      //console.log('add version of design to body');
      $("body").addClass("sales_design_v" + self.design);
      console.log(self.design);
    };

    this.getInMailCredits = function (callback) {

      if (true) {
        callback = callback ? callback : function () {};
        console.log('getInMailCredits');
        self.sendMessageToBG(
            {
              action: "getInMailCredits",
              url: document.location.href.replace(/#/g, "")
            },
            function (inMailCredits) {
              console.log('getInMailCredits callback');
              if (!inMailCredits || inMailCredits.err) {
                self.inMailCredits = false;
                return callback(false);
              }
              self.inMailCredits = inMailCredits;
              return callback(inMailCredits);
            }
        );
      }
    };

    // Add panel in LinkedIn Search
    this.addPanelLinkedInSearch = function () {
      if (Object.keys(self.userData).length > 0) {
        if (
            $(".search-results__primary-cluster").length &&
            !$(".wrapper-linkelead-panel").length
        ) {
          $(".search-results__primary-cluster").css("paddingTop", "80px");

          $(".search-results__primary-cluster").prepend(
              $(self.html.addWrapperPanel)
          );
          setTimeout(function () {
            $(".ll-ext-tags").trigger("click");
            // $(".ll-ext-tags").trigger("click");
          }, 0); // 21 07 2017 set time to 0 from 4000
          $(".connect-btn").on("click", function () {
            chrome.runtime.sendMessage({action: "goCrm"});
          });
        }
      }
    };
  }

  var linkelead = new Linkelead();

  var checkForLogout = setInterval(function () {
    if (
        document.location.href.indexOf("linkedin.com") != -1 &&
        document.location.href.indexOf("logout") != -1
    ) {
      console.log('checkForLogout');
      linkelead.sendMessageToBG({action: "stopAllProcesses"}, function (cb) {
        console.log('checkForLogout callback', cb);
      });
      clearInterval(checkForLogout);
    }
  }, 1000);

  function checkIdAfterAuth() {
    var temp = document.cookie.match(
        "(?:^|; )" +
        "msg_send".replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, "\\$1") +
        "=([^;]*)"
    );
    var link = document.location.href.indexOf("linkedin.com/sales") === -1;
    var link2 = document.location.href.indexOf("linkedin.com") === -1;

    setTimeout(function () {
      if (temp === null && link && !link2) {
        // alertify.notify("Sorry, you don't have Sales Navigator. Activate free for a month");
      }
      document.cookie =
          "msg_send=1;expires=" +
          new Date(new Date().getTime() + 24 * 60 * 60 * 1000).toUTCString();
    }, 10 * 1000);

    if (
        document.location.href.indexOf("api/v1/getUserToken?code=") != -1 ||
        document.location.href.indexOf(
            "api/v1/handlePaypalCallbackGet?userId="
        ) != -1
    ) {
      var id = $("pre").attr("data-value");
      if (id) {
        console.log('checkIdAfterAuth');
        linkelead.sendMessageToBG(
            {action: "checkUserAfterAuth", id: id},
            function (resp) {
              console.log('resp_reloadActiveTab');
              linkelead.sendMessageToBG({action: "reloadActiveTab"}, function (
                  resp
              ) {
                console.log('resp_goSales');
                linkelead.sendMessageToBG({action: "goSales"});
                window.close();
              });
            }
        );
      } else {
        //linkelead.sendMessageToBG({action: 'goCrm'});

        window.close();
      }
    }

    if (document.location.href.indexOf("api/v1/getUserToken?error=") != -1) {
      setTimeout(function () {
        window.close();
      }, 2000);
    }
  }

  checkIdAfterAuth();

  linkelead.checkUser();
})(jQuery, window);
