window.onload = function() {
    chrome.runtime.sendMessage({
        action: 'getUserId'
    }, function(response) {
        $('input[name=return]').val('http://5.9.42.61:3000/api/v1/handlePaypalCallbackGet?userId=' + response+'&amount='+localStorage.getItem('price')+'&months='+localStorage.getItem('months'))
    });
}

$(document).ready(function(){
    var price = localStorage.getItem('price');
    var months = localStorage.getItem('months');
    attachPaypalScript(price, months)
});

function attachPaypalScript(price, months){
    var paypalScript = '<script id="scr" ' +
        'src="../../../../vendor/paypal.js?merchant=7TLRKG6XFTT72"' +
        'data-button="subscribe"' +
        'data-name="Product - '+months+' Month Subscription"' +
        'data-amount="'+price+'"' +
        'data-recurrence="'+months+'"' +
        'data-period="M"' +
        'data-return="http://5.9.42.61:3000/api/v1/handlePaypalCallbackGet"' +
        'data-cancel_return="http://5.9.42.61:3000/api/v1/handlePaypalCallbackGetCancel"' +
        '>'+
        '</script>';
    $('body').append(paypalScript);
}
