(function (i, s, o, g, r, a, m) {
  i['GoogleAnalyticsObject'] = r;
  i[r] = i[r] || function () {

    (i[r].q = i[r].q || []).push(arguments)
  }, i[r].l = 1 * new Date();
  a = s.createElement(o),
      m = s.getElementsByTagName(o)[0];
  a.async = 1;
  a.src = g;
  m.parentNode.insertBefore(a, m)

})(window, document, 'script', 'https://www.google-analytics.com/analytics.js', 'ga');
ga('create', 'UA-89085044-2', 'auto');
ga('set', 'checkProtocolTask', function () {});
ga('require', 'displayfeatures');
ga('send', 'pageview');


(function ($) {
  "use strict";
  var _console = {
    log: function (data) {
      console.log(data);
      //return false
    }
  };

  function LinkeleadModel() {
    function _nextIteration(timeout) {
      if (self.processing && self.action) {
        //if(!self.retryCounter){
        self.visitCounter++;
        //}

        _console.log("NEXT ITERATION: ", self.visitCounter);

        setTimeout(function () {
          sendData(self.visitArr);
        }, Math.random() * 5000 + 2000);
        //}, timeout * 1000);
      }
    }

    function _clearVarsForMainProcessing() {
      //
      self.processing = false;
      self.requestCounter = 0;
      self.visitCounter = 0;
      self.sendCounter = "Searching...";
      self.ids = [];
      self.trackingInfo = null;
      self.csrfToken = null;
      self.template = null;
      self.makeSearchCounter = 0;
      self.makeSearchTotal = 0;
      self.counterSendDate = 0;
      self.idMeberBad = [];
      self.tempSendResponse = {};
    }

    function _updateUserConnects(userData) {
      var stopItem,
          url = "",
          arr = [],
          data = {};

      if (self.action == "connect") {
        if (self.design == 2) {
          userData.profileUrl =
              "https://www.linkedin.com/sales/profile/" +
              userData.memberId +
              "," +
              userData.authToken +
              "," +
              userData.authType +
              "?moduleKey=" +
              self.trackingInfo.moduleKey +
              "&pageKey=" +
              self.trackingInfo.pageKey +
              "&requestId=" +
              self.trackingInfo.requestId +
              "&contextId=" +
              self.trackingInfo.contextId;
        }

        _console.log("ARRAY AFTER SEND___: ", userData);

        var memberData = {
          id: userData.memberId,
          name: userData.formattedName,
          profileUrl: userData.profileUrl,
          authType: userData.authType,
          authToken: userData.authToken,
          sentDate: Date.parse(new Date())
        };

        _console.log("MEMBER DATA self.template: ", self.template.b);
        var arr = [];
        arr.push({
          memberData: memberData,
          fum: self.template.fum,
          invMess: self.template.b,
          tagsList: self.template.tagsList
        });
        url = self.domain + ":3000/api/v1/updateConnects";
        data = {sessionCookie: self.sessionCookie, connects: arr};
        self.requestToServer(
            {
              type: "PUT",
              url: url,
              data: data
            },
            function (response) {
              _console.log(response);

              if (response.err) {
              }
            }
        );
      }
    }

    function _updateVisitedIds(stopCounter) {
      var stopItem,
          url = "",
          arr = [],
          data = {};

      if (stopCounter == "stop") {
        if (self.visitCounter == 0 || !self.visitArr.length) {
          return;
        }

        stopItem = self.visitCounter;
      } else {
        stopItem = self.visitArr.length;
      }

      for (var i = 0; i < stopItem; i++) {
        if (self.action != "connect") {
          arr.push(self.visitArr[i].memberId);
        }
      }

      if (self.action == "visit") {
        url = self.domain + ":3000/api/v1/updateVisits";
        data = {sessionCookie: self.sessionCookie, visits: arr};
      } else if (self.action == "offer") {
        url = self.domain + ":3000/api/v1/updateOffers";
        data = {sessionCookie: self.sessionCookie, offers: arr};
      }

      _console.log("SENDING DATA: ", data);
      self.requestToServer(
          {
            type: "PUT",
            url: url,
            data: data
          },
          function (response) {
            _console.log(response);

            if (response.err) {
              if (self.action == "visit") {
                self.showErrorNotification =
                    "Our bad; that did not quite work right on our end. Try adding those profiles again!";
              } else if (self.action == "connect") {
                self.showErrorNotification =
                    "Oops, we encountered an error! Try adding users again.";
              } else if (self.action == "offer") {
                self.showErrorNotification =
                    "Oops, we could not add those users; our bad. Try adding them again!";
              }
            }
          }
      );
    }

    function sendData() {
      console.log('sendData');
      var timeout = Math.floor(Math.random() * (15 - 5) + 5);



    }

    this.getPostCookie = function (cb) {
      chrome.cookies.get(
          {url: "https://www.linkedin.com/wvmx/profile?trk=nav_responsive_sub_nav_wvmp", name: "JSESSIONID"},
          function (cookie) {
            self.csrfToken = cookie.value.substring(1, cookie.value.length - 1);
            self.csrfToken = cookie.value.slice(1, -1);
            cb();
          });
    };

    var self = this;

    this.oauthClientId = "78oh2m389bk3nu";
    this.oauthRedirectUri = "http://5.9.42.61:3000/api/v1/getUserToken";
    this.domain = "http://5.9.42.61"; // prod

    //this.oauthClientId = '78j6nz03bii1gn';
    //this.oauthRedirectUri = 'http://linkelead.dev:3000/api/v1/getUserToken';
    //this.domain = 'http://linkelead.dev'; // dev

    this.sessionCookie = "";
    //this.retryCounter = 0;
    this.userData = {};
    this.action = null;
    this.trackingInfo = null;
    this.csrfToken = null;
    this.template = null;
    this.processing = false;
    this.requestCounter = 0;
    this.makeSearchTotal = 0;
    this.makeSearchCounter = 0;
    this.makeSearchInPage = 25;
    this.visitCounter = 0;
    this.sendCounter = "Searching...";
    this.showNotification = false;
    this.showErrorNotification = false;
    this.ids = [];
    this.limit = 0;
    this.searchUrl = "";
    this.visitArr = [];

    this.counterSendDate = 0; // init
    this.idMeberBad = [];

    this.limitSeachUsers = 0;

    this.searchArrCounter = 0;
    this.rcCounter = "Searching...";
    this.fumData = {
      start: 0,
      count: 10,
      fields:
          "id,name,firstName,lastName,company,title,location,tags,emails,sources,displaySources,connectionDate,secureProfileImageUrl",
      sort: "CREATED_DESC"
    };
    this.parseTime = 0;
    this.connectsParseData = {
      start: 0,
      count: 50,
      fields:
          "id,name,firstName,lastName,company,title,location,tags,emails,sources,displaySources,connectionDate,secureProfileImageUrl",
      sort: "CREATED_DESC"
    };
    this.userConnections = {};
    this.followUpIds = [];
    this.refreshData = [];
    this.sendedFollowUpIds = [];
    this.connects = [];
    this.connectsOffset = 0;
    this.csrfToken = "";
    this.newTotalConnects = 0;
    this.foundConnectsArr = [];
    this.refreshArr = [];
    this.invitationPageNumb = 0;
    this.listOfInvitations = [];
    this.cancelIds = [];
    this.savingTotalInit = false;
    this.parseErrCounter = 0;

    this.design = 1;
    this.url_serch_no_sails = "";
    /* linked search variable */
    this.arraySearchLinked = []; // for serch likend
    this.limitSend = 0;
    this.processingFlag = false;
    this.processingCounter = 0;
    this.targetUserUrl = "";
    this.userGlobalData = {};
    this.statusLinkedSearch = "";

    this.setValues = function (type, searchUrl, options, design, sendResponse) {
      self.action = type;
      self.template = options;

      _console.log("TEMPLATE: ", self.template);

      self.searchUrl = searchUrl;

      _console.log("DESIGN: ", design);
      self.url_serch_no_sails = searchUrl;
      if (design == 1) {
        self.design = 1;
        self.searchUrl = searchUrl.replace(
            /\/search\?/g,
            "/search/resultCount?"
        );
      } else {
        self.design = 2;
        self.searchUrl = searchUrl.replace(/\/search\?/g, "/search/results?");
        self.searchUrl = searchUrl.replace(/\&page\=/g, "&");
      }


      self.requestToServer(
          {
            type: "GET",
            url: self.domain + ":3000/api/v1/getUserInfo",
            data: {sessionCookie: self.sessionCookie}
          },
          function (response) {
            _console.log('requestToServer ', response);

            if (response.err) {
              sendResponse({});

              self.showErrorNotification =
                  "Connection error. Please try again in a few minutes.";

              return;
            }

            if (!$.isEmptyObject(response.data.content)) {
              if (type == "visit") {
                self.limit = parseInt(
                    response.data.content.settings.visits_count
                );
                self.ids = response.data.content.visits;
              } else if (type == "connect") {
                self.limit = parseInt(response.data.content.settings.users);
                if (self.limit > 1000) {
                  self.limit = 1000;
                }
                self.ids = response.data.content.connects;
              } else if (type == "offer") {
                self.limit = parseInt(
                    response.data.content.settings.inmails_count
                );
                self.ids = response.data.content.offers;
              }
            }

            console.log('limit', self.limit, self.ids);

            self.processing = true;
            self.makeSearch(sendResponse);

            self.tempSendResponse = sendResponse;
          }
      );
    };
    /* userClick */
    this.saveCountClickSailse = function (req, sendResponse) {
      self.requestToServer(
          {
            type: "GET",
            url: self.domain + ":3000/api/v1/customerStartCount", // /api/v1/customerStartCount
            data: {sessionCookie: self.sessionCookie}
          },
          function (res) {
            // sendResponse ({status : true});
          }
      );
    };

    this.stop_progressLinkedSearch = function (request, sendResponse) {
      self.processingFlag = false;
      self.statusLinkedSearch = "Cancelled";
      if (self.action == "visit") {
        var type = "Visiting Profiles";
      } else if (self.action == "connect") {
        var type = "Sending Connection Invitations";
      }
      console.log('action1');
      sendResponse({
        status: self.processingFlag,
        progress_value: self.processingCounter + "/" + self.limitSend,
        progress_type: type,
        progress_status: self.statusLinkedSearch,
        progressInfo: {
          action: self.action,
          counter: self.processingCounter,
          limit: self.limitSend
        }
      });
    };

    this.checkProcessingLinSearch = function (sendResponse) {
      if (self.action == "visit") {
        var type = "Visiting Profiles";
      } else if (self.action == "connect") {
        var type = "Sending Connection Invitations";
      }
      console.log('action2');
      sendResponse({
        status: self.processingFlag,
        progress_value: self.processingCounter + "/" + self.limitSend,
        progress_type: type,
        progress_status: self.statusLinkedSearch,
        progressInfo: {
          action: self.action,
          counter: self.processingCounter,
          limit: self.limitSend
        }
      });
    };

    function sendDataLinked() {
      self.targetUserUrl =
          "https://www.linkedin.com/in/" +
          self.arraySearchLinked[self.processingCounter].hitInfo[
              "com.linkedin.voyager.search.SearchProfile"
              ].miniProfile.publicIdentifier;
      setTimeout(function () {
        if (self.processingFlag) {
          if (self.action == "visit") {
            $.ajax({
              type: "GET",
              url: self.targetUserUrl,
              success: function (response) {
                self.processingCounter++;
                if (self.processingCounter < self.arraySearchLinked.length) {
                  sendDataLinked();
                } else {
                  self.processingFlag = false;
                  self.statusLinkedSearch = "Done";
                }
              },
              error: function (error) {
                self.processingCounter++;
                if (self.processingCounter < self.arraySearchLinked.length) {
                  sendDataLinked();
                } else {
                  self.processingFlag = false;
                  self.statusLinkedSearch = "Done";
                }
              }
            });
          } else if (self.action == "connect") {
            var url = "";
            console.log(
                self.arraySearchLinked[self.processingCounter].hitInfo[
                    "com.linkedin.voyager.search.SearchProfile"
                    ].miniProfile.objectUrn.replace("urn:li:member:", "")
            );
            var name =
                self.arraySearchLinked[self.processingCounter].hitInfo[
                    "com.linkedin.voyager.search.SearchProfile"
                    ].miniProfile.firstName;
            self.userGlobalData = {
              authToken: "",
              authType: "",
              formattedName:
                  self.arraySearchLinked[self.processingCounter].hitInfo[
                      "com.linkedin.voyager.search.SearchProfile"
                      ].miniProfile.firstName +
                  " " +
                  self.arraySearchLinked[self.processingCounter].hitInfo[
                      "com.linkedin.voyager.search.SearchProfile"
                      ].miniProfile.lastName,
              location:
              self.arraySearchLinked[self.processingCounter].hitInfo[
                  "com.linkedin.voyager.search.SearchProfile"
                  ].location,
              memberId: self.arraySearchLinked[self.processingCounter].hitInfo[
                  "com.linkedin.voyager.search.SearchProfile"
                  ].miniProfile.objectUrn.replace("urn:li:member:", ""),
              pastPositions: [],
              pictureId: "",
              profileUrl:
                  "https://www.linkedin.com/in/" +
                  self.arraySearchLinked[self.processingCounter].hitInfo[
                      "com.linkedin.voyager.search.SearchProfile"
                      ].miniProfile.publicIdentifier,
              title:
              self.arraySearchLinked[self.processingCounter].hitInfo[
                  "com.linkedin.voyager.search.SearchProfile"
                  ].miniProfile.occupation
            };
            try {
              var data = {
                message: self.template.b.replace(/%firstname%/g, name),
                trackingId:
                self.arraySearchLinked[self.processingCounter].hitInfo[
                    "com.linkedin.voyager.search.SearchProfile"
                    ].miniProfile.trackingId,
                excludeInvitations: [],
                invitations: [],
                invitee: {
                  "com.linkedin.voyager.growth.invitation.InviteeProfile": {
                    profileId:
                    self.arraySearchLinked[self.processingCounter].hitInfo[
                        "com.linkedin.voyager.search.SearchProfile"
                        ].id
                  }
                }
              };
              self.getCookie("https://www.linkedin.com", "JSESSIONID", function (
                  cookie
              ) {
                cookie = cookie.substring(1, cookie.length - 1);
                $.ajax({
                  type: "POST",
                  url:
                      "https://www.linkedin.com/voyager/api/growth/normInvitations",
                  beforeSend: function (request) {
                    request.setRequestHeader(
                        "content-type",
                        "application/json"
                    );
                    //request.setRequestHeader('x-requested-with', 'XMLHttpRequest');
                    request.setRequestHeader("csrf-token", cookie);
                  },
                  data: JSON.stringify(data),
                  dataType: "json",
                  success: function (response) {
                    _updateUserConnects(self.userGlobalData);
                    self.processingCounter++;
                    if (
                        self.processingCounter < self.arraySearchLinked.length
                    ) {
                      sendDataLinked();
                    } else {
                      self.processingFlag = false;
                      self.statusLinkedSearch = "Done";
                    }
                  },
                  error: function (err) {
                    _updateUserConnects(self.userGlobalData);
                    self.processingCounter++;
                    if (
                        self.processingCounter < self.arraySearchLinked.length
                    ) {
                      sendDataLinked();
                    } else {
                      self.processingFlag = false;
                      self.statusLinkedSearch = "Done";
                    }
                  }
                });
              });
            } catch (err) {
              console.log("warning", err);
            }
            //self.processingFlag = false;
          }
        }
      }, Math.random() * 1500 + 1000);
    }

    this.makeSearchLinked = function () {
      self.getCookie("https://www.linkedin.com", "JSESSIONID", function (
          cookie
      ) {
        cookie = cookie.substring(1, cookie.length - 1);
        $.ajax({
          type: "GET",
          url: self.url_serch_no_sails,
          beforeSend: function (request) {
            request.setRequestHeader("content-type", "application/json");
            request.setRequestHeader("x-requested-with", "XMLHttpRequest");
            request.setRequestHeader("csrf-token", cookie);
          },
          success: function (response) {
            const pendingUser = self.userData.refresh.map(u => u.memberData.id);
            let searchProfile;
            let isPending = false;

            for (let i = 0; i < response.elements.length; i++) {
              if (response.elements[i].hitType === "PEOPLE") {
                for (let j = 0; j < response.elements[i].elements.length; j++) {
                  if (self.arraySearchLinked.length < self.limitSend) {
                    isPending = false;
                    searchProfile = response.elements[i].elements[j].hitInfo['com.linkedin.voyager.search.SearchProfile'];

                    if (pendingUser.some(u => searchProfile.backendUrn.includes(u))) {
                      isPending = true
                    }
                    if (!isPending && searchProfile.distance.value !== "DISTANCE_1" && searchProfile.distance.value !== "SELF") {
                      self.arraySearchLinked.push(
                          response.elements[i].elements[j]
                      );
                    } else {
                      self.limitSeachUsers++;
                    }
                  } else {
                    break;
                  }
                }
              }
            }
            if (self.arraySearchLinked.length < self.limitSend && self.limitSeachUsers < 2000 && response.elements.length != 0) {
              self.url_serch_no_sails = self.url_serch_no_sails.split("start=");
              self.url_serch_no_sails =
                  self.url_serch_no_sails[0] +
                  "start=" +
                  (parseInt(self.url_serch_no_sails[1]) + 25);
              self.makeSearchLinked();
            } else {
              if (self.arraySearchLinked.length != 0) {
                self.limitSeachUser = 0;
                sendDataLinked();
              } else {
                self.processingFlag = false;
                self.statusLinkedSearch = "Done";
              }
            }
          }
        });
      });
    };

    this.makeSearch = function (sendResponse) {
      var self = this;
      if (self.makeSearchCounter < 2) {
        self.makeSearchCounter = 1;
      }

      if (self.makeSearchTotal > 0 && self.makeSearchTotal <= self.makeSearchCounter) {
        console.log('page ended');
        _clearVarsForMainProcessing();

        if (self.action) {
          self.showNotification = true;
        }
        return;
      }
      console.log('PAGES SEARCH ', self.makeSearchTotal, '/', self.makeSearchCounter);

      if (self.makeSearchCounter >= 2) {
        self.searchUrl = self.searchUrl.split("&start=");

        if (self.makeSearchCounter < 1 || typeof (self.makeSearchCounter) === 'undefined') {
          self.makeSearchCounter = 1;
        }
        self.searchUrl =
            self.searchUrl[0] +
            "&start=" +
            ((self.makeSearchCounter - 1) * self.makeSearchInPage) +
            "&count=" + self.makeSearchInPage + "&page=" + self.makeSearchCounter;
      }

      console.log('SEARCH URL: ', self.searchUrl);
      $.ajax({
        type: "GET",
        url: self.searchUrl,
        beforeSend: function (request) {
          request.setRequestHeader("upgrade-insecure-requests", "1");
        },
        success: function (resp) {
          var response = {
            result: {
              searchResultsKeys: {},
              searchResults: []
            },
            trackingInfo: {
              requestId: null
            },
            pagination: {
              total: 0
            }
          };

          var data = $('<output>').append($.parseHTML(resp));
          var codeBlocks = $('code', data);
          var codeInfo = {};
          codeBlocks.each(function () {
            try {
              var json = $.parseJSON($(this).html());
              codeInfo[$(this).attr('id')] = json;
              if (typeof (json.elements) !== 'undefined') {
                json.elements.forEach(function (item) {
                  if (typeof (response.result.searchResultsKeys[item.objectUrn.split(":")[3]]) === 'undefined') {
                    response.result.searchResultsKeys[item.objectUrn.split(":")[3]] = true;
                    response.result.searchResults.push({
                      formattedName: item.fullName,
                      firstName: item.firstName,
                      memberId: item.objectUrn.split(":")[3],
                      AuthToken: item.entityUrn.split(":")[3].substring(1, item.entityUrn.split(":")[3].length - 1)
                    });
                  }
                });
                response.trackingInfo = json.metadata.tracking;
                response.pagination = json.paging;
              }
              if (typeof (json.primaryIdentity) !== 'undefined' && json.primaryIdentity !== null) {
                self.primaryIdentity = json.primaryIdentity;
              }
            } catch (e) {

            }
          });
          console.log('codeInfo', codeInfo);
          console.log('primaryIdentity', self.primaryIdentity);
          console.log("search response: ", response);

          self.makeSearchTotal = Math.ceil(response.pagination.total / response.pagination.count);

          self.makeSearchInPage = response.pagination.count;




          self.checkAndSendFindeds(response.result.searchResults, sendResponse);


//                    setTimeout(function () {
//
//
//                        if (self.design === 1) {
//                            self.checkDuplicateIds(
//                                    response.result.searchResults,
//                                    sendResponse
//                                    );
//                        } else {
//                            self.checkDuplicateIds(response.searchResults, sendResponse);
//                        }
//                    }, 2000);
        },
        error: function (err) {
          _console.log(err);

          _clearVarsForMainProcessing();
          self.processing = false;
          self.showErrorNotification = "Request denied by LinkedIn.";
        }
      });
    };

    this.searchForInMailCredits = function (searchUrl, sendResponse) {
      var url = searchUrl.replace(/\/search\?/g, "/search/resultCount?");
      url = searchUrl + "&start=0&count=10";
      console.log('getUrl', url);
      $.ajax({
        type: "GET",
        url: url,
        success: function (resp) {
          var response = {
            result: {
              searchResults: []
            },
            trackingInfo: {
              requestId: null
            }
          };
          var data = $('<output>').append($.parseHTML(resp));
          var codeBlocks = $('code', data);
          var codeInfo = {};
          codeBlocks.each(function () {
            try {
              var json = $.parseJSON($(this).html());
              codeInfo[$(this).attr('id')] = json;
              if (typeof (json.elements) !== 'undefined') {
                json.elements.forEach(function (item) {
                  response.result.searchResults.push({
                    memberId: item.objectUrn.split(":")[3],
                    AuthToken: item.entityUrn.split(":")[3].substring(1, item.entityUrn.split(":")[3].length - 1),
                  });
                });
                response.trackingInfo = json.metadata.tracking;
              }
            } catch (e) {

            }
          });
          console.log(response);
          console.log(codeInfo);

          if (response.result.searchResults.length) {
            self.getInMailCredits(response, sendResponse);
          } else {
            sendResponse({err: true});
          }
        },

        error: function (err) {
          _console.log(err);

          sendResponse({err: true});

          self.showErrorNotification =
              "This is embarrassing, but LinkedIn would not accept this request. " +
              "Try again, or maybe try a different request.";
        }
      });
    };

    this.getInMailCredits = function (searchData, sendResponse) {
//            var idWithAuthToken =
//                    searchData.result.searchResults[0].memberId +
//                    "," +
//                    searchData.result.searchResults[0].AuthToken +
//                    ",NAME_SEARCH";

      var idWithAuthToken =
          searchData.result.searchResults[0].memberId +
          "," +
          searchData.result.searchResults[0].AuthToken;

      _console.log(idWithAuthToken);

      $.ajax({
        type: "GET",
        url: "https://www.linkedin.com/sales/composeJson",
        data: {
          idWithAuthToken: idWithAuthToken,
          "trackingInfoJson.requestId": searchData.trackingInfo.requestId,
          "trackingInfoJson.contextId": searchData.trackingInfo.contextId,
          "trackingInfoJson.moduleKey": searchData.trackingInfo.moduleKey,
          "trackingInfoJson.pageKey": searchData.trackingInfo.pageKey
        },
        success: function (response) {
          _console.log("response: ", response);

          if (response) {
            sendResponse(response.inMailCredits);
          } else {
            sendResponse(false);
          }
        },
        error: function (err) {
          _console.log(err);

          self.showErrorNotification = "Request denied by LinkedIn.";
        }
      });
    };

    this.checkAndSendFindeds = function (results, sendResponse) {
      if (this.action === 'connect' || this.action === 'visit') {
        this.firstGetFullList();
        console.log('from page data', results);
        console.log('checkDuplicateIds results', results.length);
        console.log('self.action', this.action);
        console.log('self.ids ', this.ids);
        var count = results.length;

        var self = this;
        this.startInv(results, function (item, cb) {
          if (self.sendToSrvDataArr.length >= self.limit) {
            cb();
          } else {
            if (typeof (self.firstGetFullList[item.memberId]) === 'undefined') {
              self.firstGetFullListArr[item.memberId] = item;
              if (self.action === 'connect') {
                console.log('send invintation');
                setTimeout(function () {
                  self.visitPage('https://www.linkedin.com/sales/people/' + item.AuthToken, function (status) {
                    if (status) {
                      self.getPostCookie(function () {
                        self.sendConnectInvitation(item, function (result) {
                          if (result === true) {
                            self.sendCounter++;
                            self.sendToSrvDataArr.push(item);
                          }
                          cb();
                        });
                      });
                    } else {
                      cb();
                    }
                  });
                }, 500);
              } else if (self.action === 'visit') {
                console.log('send visitation');
                setTimeout(function () {
                  self.visitPage('https://www.linkedin.com/sales/people/' + item.AuthToken, function (result) {
                    if (result === true) {
                      self.sendCounter++;
                      self.sendToSrvDataArr.push(item);
                    }
                    cb();
                  });
                }, Math.random() * 500 + 200);
              } else {
                console.log('ERROR ACTION', self.action);
              }
            } else {
              cb();
            }
          }
        }, function () {
          if (self.sendToSrvDataArr.length < self.limit) {
            console.log('end page ', self.sendToSrvDataArr.length, self.limit);
            self.makeSearchCounter++;
            self.makeSearch(sendResponse);
          } else if (self.sendToSrvDataArr.length >= self.limit) {
            console.log('end page2 ', self.sendToSrvDataArr.length, self.limit);
            setTimeout(function () {
              self.showNotification = true;
              _clearVarsForMainProcessing();
            }, 5000);
          } else {
            console.log('end page3 ', self.sendToSrvDataArr.length, self.limit);

          }
        });
      }
    };


    this.startInv = function (results, callback, cb) {
      var self = this;
      if (results.length > 0) {
        var item = results.shift();
        callback(item, function () {
          self.startInv(results, callback, cb);
        });
      } else {
        cb();
      }
    };


    this.firstGetFullList = function () {
      if (typeof (this.firstGetFullListArr) === 'undefined') {
        this.sendToSrvDataArr = [];
        this.firstGetFullListArr = {};
        for (var i = 0; i < this.ids.length; ++i) {
          this.firstGetFullListArr[this.ids[i].memberData.id] = this.ids[i];
        }
      }
      if (typeof (this.actionStatus) === 'undefined') {
        this.actionStatus = 'started';
        this.sendCounter = 0;
      }
    };

//
//
//        this.checkDuplicateIds = function (results, sendResponse) {
//            console.log('self.ids ', self.ids);
//            //console.log(self.ids)
//            console.log('checkDuplicateIds results', results.length);
//            console.log('self.action', self.action);
//            for (var i = 0; i < results.length; i++) {
//                if (self.design === 1) {
//                    if (self.action === "visit") {
//                        results[i].formattedName = results[
//                                i
//                        ].formattedName.replace(/&#(\d+);/g, function (m, n) {
//                            return String.fromCharCode(n);
//                        });
//                        try {
//                            results[i].isOpenLink = results[i].badges.isOpenlink;
//                        } catch (err) {
//                        }
//                        self.visitArr.push(results[i]);
//                    } else {
//                        if (results[i].badges) {
//                            if (results[i].badges.distance !== 1) {
//                                results[i].formattedName = results[
//                                        i
//                                ].formattedName.replace(/&#(\d+);/g, function (m, n) {
//                                    return String.fromCharCode(n);
//                                });
//                                try {
//                                    results[i].member.isOpenLink = results[i].badges.isOpenlink;
//                                } catch (err) {
//                                }
//
//                                self.visitArr.push(results[i]);
//                            }
//                        } else {
//                            results[i].formattedName = results[
//                                    i
//                            ].formattedName.replace(/&#(\d+);/g, function (m, n) {
//                                return String.fromCharCode(n);
//                            });
//                            try {
//                                results[i].isOpenLink = results[i].badges.isOpenlink;
//                            } catch (err) {
//                            }
//                            self.visitArr.push(results[i]);
//                        }
//                    }
//                } else {
//                    if (self.action === "visit") {
//                        results[i].member.formattedName = results[
//                                i
//                        ].member.formattedName.replace(/&#(\d+);/g, function (m, n) {
//                            return String.fromCharCode(n);
//                        });
//                        try {
//                            results[i].member.isOpenLink = results[i].badges.isOpenlink;
//                        } catch (err) {
//                        }
//                        self.visitArr.push(results[i].member);
//                    } else {
//                        if (results[i].badges) {
//                            if (results[i].badges.distance != 1) {
//                                results[i].member.formattedName = results[
//                                        i
//                                ].member.formattedName.replace(/&#(\d+);/g, function (m, n) {
//                                    return String.fromCharCode(n);
//                                });
//                                try {
//                                    results[i].member.isOpenLink = results[i].badges.isOpenlink;
//                                } catch (err) {
//                                }
//                                self.visitArr.push(results[i].member);
//                            }
//                        }
//                    }
//                }
//
//                console.log("RESULTS I: ", results[i]);
//            }
//            console.log(self.ids);
//            console.log('self.visitArr', self.visitArr);
//
//            self.visitArr = self.visitArr.reduce(function (prev, value) {
//                var isDuplicate = false;
//
//                for (var i = 0; i < self.ids.length; i++) {
//                    var id;
//                    console.log('self.action', self.action);
//                    if (self.ids[i].memberData) {
//                        id = parseInt(self.ids[i].memberData.id);
//                    } else if (self.action !== "connect") {
//                        id = parseInt(self.ids[i]);
//                    } else {
//                        id = parseInt(self.ids[i].id);
//                    }
//                    console.log('reduce', value.memberId, id);
//                    if (value.memberId === id) {
//                        isDuplicate = true;
//                        console.log('isDuplicate', isDuplicate);
//                        break;
//                    }
//                }
//
//                if (isDuplicate === false) {
//                    console.log('isDuplicate push');
//                    prev.push(value);
//                }
//
//                return prev;
//            }, []);
//            console.log('self.visitArr', self.visitArr);
//
//            self.removeDuplicateMembers();
//
//            // _console.log('CHECK VISITS: ', self.visitArr.length, self.limit, self.makeSearchCounter, self.makeSearchTotal);
//            console.log(
//                    "CHECK VISITS: ",
//                    self.limit,
//                    self.limit,
//                    self.makeSearchCounter,
//                    self.makeSearchTotal
//                    );
//            console.log('self.visitArr.length', self.visitArr.length);
//            console.log('self.limit', self.limit);
//
//            if (self.visitArr.length === self.limit) {
//                for (var i = 0; i < self.visitArr.length; i++) {
//                    console.log(
//                            "visitArr: ",
//                            self.visitArr[i].formattedName,
//                            self.visitArr[i].memberId
//                            );
//                }
//
//                sendData();
//            } else if (self.visitArr.length > self.limit) {
//                var arr = [];
//
//                for (var i = 0; i < self.limit; i++) {
//                    arr.push(self.visitArr[i]);
//                }
//
//                self.visitArr = arr;
//
//                for (var i = 0; i < self.visitArr.length; i++) {
//                    console.log(
//                            "visitArr: ",
//                            self.visitArr[i].formattedName,
//                            self.visitArr[i].memberId
//                            );
//                }
//                console.log(arr);
//                sendData();
//            } else if (
//                    self.visitArr.length < self.limit &&
//                    self.makeSearchCounter < self.makeSearchTotal &&
//                    results.length
//                    ) {
//                self.makeSearch(sendResponse);
//            } else {
//                for (var i = 0; i < self.visitArr.length; i++) {
//                    console.log(
//                            "visitArr: ",
//                            self.visitArr[i].formattedName,
//                            self.visitArr[i].memberId
//                            );
//                }
//
//                sendData();
//            }
//
//            //_console.log(self.visitArr.length);
//            _console.log('self.limit', self.limit);
//        };

    this.visitPage = function (url, callback) {
      try {
        $.ajax({
          type: "GET",
          url: url,
          success: function (response) {
            callback(true);
          },
          error: function (err) {
            callback(false);
          }
        });
      } catch (err) {
        callback(false);
      }
    };

    this.sendConnectInvitation = function (userData, callback) {
      var self = this;
//                        tempUrl = 'https://www.linkedin.com/sales-api/salesApiConnection?action=connect';

      console.log("USER-DATA", userData);

      var url =
              "https://www.linkedin.com/sales-api/salesApiConnection?action=connect",
          templateBody = "",
          data = {};

      function _send() {
        $.ajax({
          type: "POST",
          url: url,
          data: JSON.stringify(data),
          dataType: "json",
          beforeSend: function (request) {
            request.setRequestHeader("content-type", "application/json");

            request.setRequestHeader('x-li-identity', self.primaryIdentity);
            request.setRequestHeader('x-li-lang', 'en_US');
//                                request.setRequestHeader('x-li-page-instance', 'urn:li:page:d_sales2_profile;8jNg1UUNTBuF0PLpazAUEA==');
            request.setRequestHeader('x-restli-protocol-version', '2.0.0');
            request.setRequestHeader('x-requested-with', 'XMLHttpRequest');
            request.setRequestHeader("csrf-token", self.csrfToken);

//                        request.setRequestHeader("X-CSRF-Token", self.csrfToken);
          }
        }).done(function (response) {

          console.log('SEND INVINTAT', self.sendCounter);
          _updateUserConnects(userData);
          callback(true);
        }).fail(function (err) {
          console.log('senddd ERR', err);
          callback(false);
//                    _clearVarsForMainProcessing();
//                    self.processing = false;
//                    self.showErrorNotification =
//                            "Looks like our server hiccupped! We will get right on it, but in the " +
//                            "meantime try sending invitations again.";
        });
      }

      if (self.processing) {
        if (userData.firstName) {
          templateBody = self.template.b.replace(/%firstname%/g, userData.firstName);
        } else {
          templateBody = self.template.b.replace(
              /%firstname%/g,
              userData.formattedName
          );
        }


        data = {
          isEmailRequired: false,
          member: userData.AuthToken.split(',')[0],
          message: templateBody
        };


        _send();
      } else {
        console.log('INVINTATION PROCESSING FALSE');
      }
    };

    this.updateerrcounter = function () {
      $.ajax(
          {
            type: "GET",
            url: "http://5.9.42.61:3000/api/v1/errorPlanCount",
            data: {sessionCookie: self.sessionCookie}
          },
          function (res) {
            console.log(res);
          }
      );
    };

//        this.sendConsultingOffer = function (userData, callback) {
//            _console.log("userData: ", userData);
//            _console.log("requestId: ", self.trackingInfo.requestId);
//
//            try {
//                if (
//                        (self.userData.inmails_count !== 1) || userData.isOpenLink) {
//                    console.log("go msg");
//                    self.counterSendDate++;
//                } else {
//                    self.idMeberBad.push(userData.memberId);
//
//                    console.log("return");
//                    if (self.sendCounter == "Searching...") {
//                        self.sendCounter = 0;
//                    }
//                    self.sendCounter++;
//                    callback(true);
//                    return;
//                }
//            } catch (err) {
//                self.visitCounter = 0;
//                self.makeSearch(self.tempSendResponse); //
//                console.log("end i fink");
//                return;
//            }
//
//            function _getFirstName(callback) {
//                $.ajax({
//                    type: "GET",
//                    url:
//                            "https://www.linkedin.com/sales/profile/" +
//                            userData.memberId +
//                            "," +
//                            userData.authToken +
//                            "," +
//                            userData.authType +
//                            "/pathfinder",
//                    dataType: "json",
//                    success: function (response) {
//                        _console.log(response);
//
//                        callback(response.viewee.firstName);
//                    },
//                    error: function (err) {
//                        _console.log(err);
//
//                        callback(false);
//                    }
//                });
//            }
//
//            var url =
//                    "https://www.linkedin.com/sales/api/v1/sendMessage?csrfToken=" +
//                    self.csrfToken,
//                    templateBody = "",
//                    data = {};
//
//            function _send() {
//                $.ajax({
//                    type: "POST",
//                    url: url,
//                    data: JSON.stringify(data),
//                    //'contentType': "application/json; charset=utf-8",
//                    dataType: "json",
//                    beforeSend: function (request) {
//                        request.setRequestHeader("content-type", "application/json");
//                        request.setRequestHeader("x-requested-with", "XMLHttpRequest");
//                        request.setRequestHeader("X-CSRF-Token", self.csrfToken);
//                    },
//                    success: function (response) {
//                        callback(true);
//
//                        if (self.sendCounter == "Searching...") {
//                            self.sendCounter = 0;
//                        }
//
//                        self.sendCounter++;
//                    },
//                    error: function (err) {
//                        _console.log(err);
//
//                        _clearVarsForMainProcessing();
//                        self.processing = false;
//
//                        if (err.status == 402 && err.statusText == "Payment Required") {
//                            self.showErrorNotification =
//                                    "You have been busy! Unfortunately, you will need additional InMail" +
//                                    " credit to keep sending out offers.";
//                        } else {
//                            self.showErrorNotification =
//                                    "Submit your consulting offers again, we had an error on our end. " +
//                                    "Thanks for understanding!";
//                        }
//                    }
//                });
//            }
//
//
//            if (userData.firstName) {
//                templateBody = self.template.b.replace(/%firstname%/g, userData.firstName);
//            } else {
//                templateBody = self.template.b.replace(
//                        /%firstname%/g,
//                        userData.formattedName
//                        );
//            }
//
//            data = {
//                idWithAuthToken:
//                        userData.memberId + "," + userData.authToken + ",NAME_SEARCH",
//                category: "DEALS",
//                subject: self.template.t,
//                body: templateBody,
//                isInMail: true,
//                mediaIds: []
//            };
//
//            _send();
//        };

    this.getUserSettings = function (sendResponse) {
      self.requestToServer(
          {
            type: "GET",
            url: self.domain + ":3000/api/v1/getUserInfo",
            data: {
              sessionCookie: self.sessionCookie
            }
          },
          function (response) {
            _console.log(response);

            if (response.err) {
              sendResponse({err: true});
              self.showErrorNotification =
                  "Connection error. Please try again in a few minutes.";
            } else if (!$.isEmptyObject(response.data.content)) {
              sendResponse(response.data.content);

              if (response.data.content.refresh) {
                if (!response.data.content.refresh.length) {
                  self.connects = response.data.content.connects;
                } else {
                  self.connects = response.data.content.refresh;
                }
              }
            } else {
              sendResponse({});
              //self.showErrorNotification = 'Whoa! It looks like our server is having problems communicating. Try again in a few minutes.';
            }
          }
      );
    };

    this.updateUserSettings = function (settings, sendResponse) {
      _console.log(settings);
      self.requestToServer(
          {
            type: "PUT",
            url: self.domain + ":3000/api/v1/updateSettings",
            data: {
              sessionCookie: self.sessionCookie,
              settings: settings
            }
          },
          function (response) {
            _console.log(response);

            if (response.err) {
              sendResponse(false);

              self.showErrorNotification =
                  "Your settings were not saved due to a server error. Try again and it should work.";

              return;
            }

            if (response) {
              sendResponse(true);
            }
          }
      );
    };

    this.updateNotifications = function (notifications, sendResponse) {
      console.log(notifications);
      self.requestToServer(
          {
            type: "PUT",
            url: self.domain + ":3000/api/v1/updateNotifications",
            data: {
              sessionCookie: self.sessionCookie,
              notifications: notifications
            }
          },
          function (response) {
            _console.log(response);

            if (response.err) {
              sendResponse(false);

              self.showErrorNotification =
                  "Your notifications were not saved due to a server error. Try again and it should work.";

              return;
            }

            if (response) {
              sendResponse(true);
            }
          }
      );
    };

    this.requestToServer = function (options, callback) {
      $.ajax({
        type: options.type,
        url: options.url,
        data: options.data,
        success: function (response) {
          callback(response);
        },
        error: function (err) {
          callback({err: err});
        }
      });
    };

    this.cancelProcessing = function () {
      self.processing = false;
      self.invitationPageNumb = 0;
      self.listOfInvitations = [];
      self.showNotification = false;
      self.showErrorNotification = false;
    };

    this.checkProcessing = function (sendResponse) {
      //_console.log('SHOW: ', self.showNotification);

      if (self.action != "refresh" && self.action != "cancel") {
        console.log('action3', self.action);
        var send = {
          processing: self.processing,
          progressInfo: {
            action: self.action,
            counter: self.sendToSrvDataArr.length,
            limit: self.limitSend
          },
          showNotification: [self.showNotification, self.sendToSrvDataArr.length],
          showErrorNotification: self.showErrorNotification
        };
        console.log('send', send)
        sendResponse(send);

        if (self.showNotification || self.showErrorNotification) {
          self.sendToSrvDataArr = [];
          self.showNotification = false;
          self.showErrorNotification = false;
        }
      } else if (self.action == "refresh") {
        //_console.log('COUNTER: ', self.rcCounter);

        console.log('action4', self.action);
        sendResponse({
          processing: self.processing,
          progressInfo: {
            action: self.action,
            counter: self.rcCounter,
            limit: self.connectsOffset
          },
          refreshArr: self.refreshArr,
          showNotification: [self.showNotification, self.connectsOffset],
          showErrorNotification: self.showErrorNotification
        });

        if (self.showNotification || self.showErrorNotification) {
          self.action = null;
          self.showNotification = false;
          self.showErrorNotification = false;
          _clearVarsForRefresh("end");
        }
      } else if (self.action == "cancel") {
        //_console.log('3');
        console.log('action5', self.action);
        sendResponse({
          processing: self.processing,
          progressInfo: {
            action: self.action,
            counter: "Searching...",
            limit: null
          },
          showNotification: [
            self.showNotification,
            self.listOfInvitations.length
          ],
          showErrorNotification: self.showErrorNotification
        });

        if (self.showNotification || self.showErrorNotification) {
          self.cancelProcessing();
        }
      }
    };

    this.saveCurrentTab = function (sendResponse) {
      chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
        chrome.storage.local.set({activeTab: tabs[0].id}, function () {
          sendResponse(true);
        });
      });
    };

    this.reloadActiveTab = function (sendResponse) {
      chrome.storage.local.get("activeTab", function (data) {
        _console.log("activeTab: ", data);

        chrome.windows.getAll({populate: true}, function (w) {
          for (var i = 0; i < w.length; i++) {
            if (w[i].tabs.length) {
              for (var j = 0; j < w[i].tabs.length; j++) {
                if (w[i].tabs[j].id == data.activeTab && w[i].tabs[j].active) {
                  chrome.tabs.reload(w[i].tabs[j].id, {}, function (resp) {
                    sendResponse(true);

                    chrome.storage.local.remove("activeTab");
                  });
                }
              }
            }
          }
        });
      });
    };

    this.checkUserAfterAuth = function (id, sendResponse) {
      _console.log("id: ", id);

      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/updateAfterAuth",
              data: {
                id: id,
                sessionCookie: cookie
              }
            },
            function (response) {
              sendResponse(true);
              chrome.runtime.sendMessage({action: "reloadPage"}, function (
                  resp
              ) {});
            }
        );
      });
    };

    this.saveGAClientId = function () {
      self.getCookie("https://www.linkedin.com", "li_at", function (sessionCookie) {
        self.getCookie('http://linkelead.com', '_ga-first', function (gaFirst) {
          // console.log("gaFirst", gaFirst);
          var gaClientId = gaFirst ? gaFirst : "None";

          return self.requestToServer(
              {
                type: "POST",
                url: self.domain + ":3000/api/v1/saveGAClientId",
                data: {
                  gaClientId: gaClientId,
                  sessionCookie: sessionCookie
                }
              },
              function (response) {
                if (response.err) {
                  console.log(response.err)
                }
              }
          );
        });
      });
    };

    this.checkSession = function (login, sendResponse) {

      console.log('CHECK SESSION');
      self.getCookie("https://www.linkedin.com", "li_at", function (response) {
        console.log('response', response);
        _console.log("cookie: ", response, login);

        self.sessionCookie = response;

        if (login) {
          if (sendResponse) {
            sendResponse(response);
          }
        } else {
          self.requestToServer(
              {
                type: "GET",
                url: self.domain + ":3000/api/v1/getUserInfo",
                data: {
                  sessionCookie: response
                }
              },
              function (response) {
                _console.log('CHECK SESSION MY: ', response);

                if (response.err) {
                  sendResponse({err: true});
                  self.userData = {};
                  chrome.browserAction.setIcon({
                    path: "../icons/icon-grey.png"
                  });

                  self.showErrorNotification =
                      "Connection error. Please try again in a few minutes.";

                  return;
                } else if (!$.isEmptyObject(response.data)) {

                  try {
                    sendResponse(response.data.content);
                  } catch (err) {
                    console.log(err);
                  }

                  self.userData = response.data.content;

                  if (!$.isEmptyObject(self.userData.connections)) {
                    _console.log(
                        "CONNECTIONS LENGTH: ",
                        Object.keys(self.userData.connections).length
                    );
                  }

                  if (response.data.content.connects) {
                    if (!response.data.content.refresh.length) {
                      self.connects = response.data.content.connects;
                    } else {
                      self.connects = response.data.content.refresh;
                    }

                    if (response.data.content.totalConnects == 0 && !self.savingTotalInit) {
                      _console.log("THIS");
                      self.savingTotalInit = true;
                      self.checkTotalConnects("save", null);
                    }

                    //chrome.storage.local.get('totalConnects', function (value) {
                    //_console.log(value);
                    //_console.log('empty totalConnects: ', $.isEmptyObject(value));

                    //if ($.isEmptyObject(value)) {
                    //self.checkTotalConnects();
                    //}
                    //});
                  }
                } else {
                  sendResponse({});
                  self.userData = {};
                  chrome.browserAction.setIcon({
                    path: "../icons/icon-grey.png"
                  });
                }
              }
          );
        }
      });
    };

    this.submitStripeForm = function (data, coupon, sendResponse) {
      _console.log("stripe token: ", data);

      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        data.sessionCookie = cookie;
        data.coupon = coupon;

        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/parseStripeForm",
              data: data
            },
            function (response) {
              _console.log(response);

              if (response.err) {
                var err = JSON.parse(response.err.responseText);

                sendResponse({err: err.error.message});
              } else {
                sendResponse({success: true});
              }
            }
        );
      });
    };

    // Get cookies
    this.getCookie = function (domain, name, callback) {
      var self = this;
      if (typeof (self.sessionCookieFinded) === 'undefined') {
        self.sessionCookieFinded = {};
      }
      if (typeof (self.sessionCookieFinded[name]) !== 'undefined') {
        callback(self.sessionCookieFinded[name]);
      } else {
        chrome.cookies.getAll({url: domain}, function (cookies) {
          cookies.forEach(function (cookie) {
            console.log(name, cookie);
            if (cookie.name === name) {
              self.sessionCookieFinded[name] = cookie.value;
              callback(cookie.value);
              return;
            }
          });
          callback(null);
        });
      }
    };

    this.getPlanInfo = function (sendResponse) {
      self.requestToServer(
          {
            type: "GET",
            url: self.domain + ":3000/api/v1/getPlanInfo",
            data: {}
          },
          function (response) {
            _console.log(response);

            if (response.err) {
              self.showErrorNotification =
                  "Submit your request again, we had an error on our end. Thanks for understanding!";

              return;
            }

            if (response.data) {
              sendResponse({plan: response.data.content});
            } else {
              sendResponse({planErr: "There is no subscribe plan"});
            }
          }
      );
    };

    function _clearVarsForRefresh(type) {
      _console.log("STOP REFRESH: ", self.connects, type);

      if (type == "stop") {
        if (self.connects.length) {
          var _updatedConnects = [false];

          if (self.sendedFollowUpIds.length) {
            _updatedConnects = self.sendedFollowUpIds;
          }

          self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
            if (cookie) {
              self.requestToServer(
                  {
                    type: "POST",
                    url: self.domain + ":3000/api/v1/updateUserConnects",
                    data: {
                      sessionCookie: cookie,
                      updatedConnects: _updatedConnects
                    }
                  },
                  function (response) {
                    _console.log("UPDATE USER CONNECTS: ", response);

                    self.sendedFollowUpIds = [];
                    self.followUpIds = [];

                    if (response.err) {
                      self.showErrorNotification =
                          "We could not refresh your number of connections due to a server error. Try again!";
                    }

                    self.userData.totalConnects = self.newTotalConnects;
                  }
              );
            }
          });
        }
      }

      self.searchArrCounter = 0;
      self.rcCounter = "Searching...";
      self.fumData = {
        start: 0,
        count: 10,
        fields:
            "id,name,firstName,lastName,company,title,location,tags,emails,sources,displaySources,connectionDate,secureProfileImageUrl",
        sort: "CREATED_DESC"
      };
      self.connectsOffset = 0;
      self.csrfToken = "";
      self.refreshData = [];
      self.refreshArr = [];
      self.foundConnectsArr = [];
    }

    this.cancelConnectInvitationsInit = function () {
      _console.log("PROCESSING: ", self.processing);
      if (!self.processing) {
        self.processing = true;
        self.action = "cancel";

        self.formListOfInvites();
      }
    };

    this.formListOfInvites = function () {
      $.ajax({
        type: "GET",
        url:
            "https://www.linkedin.com/people/invites/scroll?pageNum=" +
            self.invitationPageNumb +
            "&pageSize=50",
        success: function (response) {
          _console.log(response);

          if (response) {
            if (response.content) {
              if (response.content.contacts_or_invites.sections) {
                _console.log(
                    "FORM LIST: ",
                    response.content.contacts_or_invites.sections
                );

                for (
                    var j = 0;
                    j < response.content.contacts_or_invites.sections.length;
                    j++
                ) {
                  var now = new Date().getTime(),
                      date = new Date(
                          response.content.contacts_or_invites.sections[j].header
                              .title
                      ).getTime(),
                      days = 0;
                  days = Math.floor((now - date) / (24 * 60 * 60 * 1000));

                  if (days > 30) {
                    var data =
                        response.content.contacts_or_invites.sections[j].people;
                    if (data.length) {
                      for (var i = 0; i < data.length; i++) {
                        self.listOfInvitations.push(data[i].invitationId);
                        self.cancelIds.push(data[i].memberId);
                      }
                    }
                  }
                }

                self.invitationPageNumb++;

                setTimeout(function () {
                  _console.log("PROCESSING: ", self.processing);
                  if (self.processing) {
                    self.formListOfInvites();
                  }
                }, 1000);
              } else {
                _console.log("PROCESSING: ", self.processing);
                if (self.processing) {
                  self.cancelConnectInvitations();
                }
              }
            }
          }
        },
        error: function (err) {
          _console.log(err);

          _clearVarsForRefresh("stop");
          self.processing = false;
          self.showErrorNotification =
              "Looks like our server hiccupped! We will get right on it, but in the" +
              " meantime try viewing the list again.";
        }
      });
    };

    this.cancelConnectInvitations = function () {
      if (self.listOfInvitations.length > 0) {
        self.getCookie("https://www.linkedin.com", "JSESSIONID", function (
            cookie
        ) {
          cookie = cookie.substring(1, cookie.length - 1);

          $.ajax({
            type: "POST",
            url:
                "https://www.linkedin.com/people/invites/withdraw?isInvite=true",
            data: {
              csrfToken: cookie,
              sourceAlias: "0_eqpRagisDCZRFfO-osrMmImU8xLahdPc4c6kCTz0c98",
              Ids: self.listOfInvitations.join(",")
            },
            beforeSend: function (request) {
              request.setRequestHeader(
                  "content-type",
                  "application/x-www-form-urlencoded; charset=UTF-8"
              );
              request.setRequestHeader("x-requested-with", "XMLHttpRequest");
            },
            success: function (response) {
              _console.log("SUCCESS RESPONSE", response);

              //if (response) {
              //self.processing = false;
              //self.showNotification = true;
              //}
            },
            error: function (err) {
              _console.log(err);

              self.showErrorNotification =
                  "Looks like our server hiccupped! We will getright on it, but in " +
                  "the meantime try cancelling those invitations again.";
            }
          }).done(function () {
            _console.log("DONE");

            var _cancelIds = [false];

            if (self.cancelIds.length) {
              _cancelIds = self.cancelIds;
            }

            self.getCookie("https://www.linkedin.com", "li_at", function (
                cookie
            ) {
              self.requestToServer(
                  {
                    type: "POST",
                    url: self.domain + ":3000/api/v1/updateUserConnects",
                    data: {
                      sessionCookie: cookie,
                      updatedConnects: _cancelIds
                    }
                  },
                  function (response) {
                    _console.log("UPDATE USER CONNECTS: ", response);

                    self.cancelIds = [];

                    if (response.err) {
                      self.showErrorNotification =
                          "We could not refresh your number of connections due to a server error. Try again!";
                    }

                    self.userData.totalConnects = self.newTotalConnects;
                  }
              );
            });

            self.processing = false;
            self.showNotification = true;
          });
        });
      } else {
        self.processing = false;
        self.showNotification = true;
      }
    };

    this.refreshConnectsInit = function (sendResponse) {
      self.action = "refresh";
      if (!self.connects.length || !self.userData.refresh.length) {
        self.showNotification = true;

        setTimeout(function () {
          if (self.userData.settings.cancelConnection) {
            self.cancelConnectInvitationsInit();
          }
        }, 1000);
      } else {
        self.getCookie("https://www.linkedin.com", "JSESSIONID", function (
            cookie
        ) {
          self.csrfToken = cookie.substring(1, cookie.length - 1);
          self.csrfToken = cookie.slice(1, -1);

          self.checkTotalConnects("get", function (connects) {
            _console.log("get user connects: ", connects);

            //self.userData.totalConnects = 2900;
            //self.userData.totalConnects = response.paging.total;

            _console.log(
                "INIT TOTAL CONNECTS: ",
                self.userData.totalConnects,
                connects
            );

            if (self.userData.totalConnects < connects) {
              self.connectsOffset = connects - self.userData.totalConnects;
              self.newTotalConnects = connects;

              self.processing = true;
              self.rcCounter = "Searching...";

              self.connectsSearch(sendResponse);
            } else {
              _console.log("SHOW NOTIFICATION");
              self.showNotification = true;

              setTimeout(function () {
                if (self.userData.settings.cancelConnection) {
                  self.cancelConnectInvitationsInit();
                }
              }, 1000);
            }
          });
        });
      }
    };

    function _stopRefreshSearch() {
      self.processing = false;
      self.showNotification = true;

      setTimeout(function () {
        if (self.userData.settings.cancelConnection) {
          self.cancelConnectInvitationsInit();
        }
      }, 1000);
    }

    this.connectsSearch = function (sendResponse) {
      _console.log("start: ", self.fumData.start);

      self.getUserConnects(self.fumData, function (resp) {
        _console.log("search res length: ", resp);

        if (resp.err) {
          return;
        }

        if (resp.values.length) {
          self.checkContactsForSendingData(resp.values, sendResponse);
        } else {
          _console.log("stop");

          _stopRefreshSearch();
        }
      });
    };

    this.checkContactsForSendingData = function (arr, sendResponse) {
      if (self.processing) {
        _console.log(
            "Offset and counter: ",
            self.connectsOffset,
            self.searchArrCounter
        );

        var length,
            nextIteration = false;

        if (self.connectsOffset <= 10) {
          length = self.connectsOffset;
          _console.log("1: ", length);
        } else if (self.connectsOffset - self.searchArrCounter <= 10) {
          length = self.connectsOffset - self.searchArrCounter;
          _console.log("2: ", length);
        } else {
          length = 10;
          _console.log("3: ", length);

          if (arr.length < length) {
            length = arr.length;
          }

          nextIteration = true;
        }

        _console.log("Contacts array: ", arr.length);
        _console.log("LENGTH: ", length, self.foundConnectsArr);

        for (var i = 0; i < length; i++) {
          _console.log(i, length, arr.length, arr);
          for (var j = 0; j < self.connects.length; j++) {
            var id;

            if (self.connects[j].id) {
              id = self.connects[j].id;
            } else {
              id = self.connects[j].memberData.id;
            }

            if (arr[i].memberId == parseInt(id)) {
              _console.log("true connect: ", self.connects[j]);

              var memberData = {},
                  obj = {};

              memberData.id = arr[i].memberId;
              memberData.name = arr[i].fullName;
              memberData.profileImageUrl = arr[i].profileImageUrl;
              memberData.profileUrl = arr[i].profileUrl;

              if (self.connects[j].memberData) {
                if (self.connects[j].memberData.authToken) {
                  memberData.authToken = self.connects[j].memberData.authToken;
                }

                if (self.connects[j].memberData.authType) {
                  memberData.authType = self.connects[j].memberData.authType;
                }
              }

              obj.memberData = memberData;
              obj.fum = self.connects[j].fum;
              obj.tagsList = self.connects[j].tagsList;

              self.foundConnectsArr.push(obj);
            }
          }
        }

        _console.log("NEXT: ", nextIteration);
        _console.log("REFRESH ARR: ", self.refreshArr);

        if (nextIteration) {
          self.searchArrCounter += 10;
          self.fumData.start += 10;

          var timeout = Math.floor(1 + Math.random() * (5 - 1));

          setTimeout(function () {
            self.connectsSearch(sendResponse);
          }, timeout * 1000);
        } else {
          self.processing = false;

          if (self.foundConnectsArr.length) {
            self.refreshArr = self.foundConnectsArr;
          } else {
            _console.log("SHOW NOTIFICATION");
            _clearVarsForRefresh("end");
            self.showNotification = true;
          }
        }
      } else {
        _clearVarsForRefresh("end");
      }
    };

    this.refreshLoopNextIteration = function () {
      _console.log(
          "CHECK MEMBERDATA 1: ",
          self.refreshData.length,
          self.rcCounter
      );

      var timeout = Math.floor(1 + Math.random() * (10 - 1));

      self.sendedFollowUpIds.push(
          self.refreshData[self.rcCounter].memberData.id
      );

      self.rcCounter++;

      setTimeout(function () {
        self.refreshLoop();
      }, timeout * 1000);
    };

    this.refreshLoop = function () {
      _console.log("PROCESSING: ", self.processing);
      _console.log(self.rcCounter + "--" + self.refreshData.length);

      if (self.processing) {
        if (self.rcCounter < self.refreshData.length) {
          _console.log(
              "check for fum: ",
              self.refreshData[self.rcCounter].fum != "false"
          );

          if (self.refreshData[self.rcCounter].fum != "false") {
            self.sendFollowUpMessage(
                self.refreshData[self.rcCounter].memberData,
                self.refreshData[self.rcCounter].fum,
                function (resp) {
                  _console.log(
                      "check for tags: ",
                      self.refreshData[self.rcCounter].tagsList != "false"
                  );

                  if (self.processing) {
                    if (self.refreshData[self.rcCounter].tagsList != "false") {
                      self.addTags(
                          self.refreshData[self.rcCounter].memberData.id,
                          self.refreshData[self.rcCounter].tagsList,
                          function (resp) {
                            self.refreshLoopNextIteration();
                          }
                      );
                    } else {
                      self.refreshLoopNextIteration();
                    }
                  }
                }
            );
          } else {
            _console.log("TAGS");
            self.addTags(
                self.refreshData[self.rcCounter].memberData.id,
                self.refreshData[self.rcCounter].tagsList,
                function (resp) {
                  self.refreshLoopNextIteration();
                }
            );
          }
        } else {
          _console.log("THIS STOP");

          self.processing = false;
          self.showNotification = true;

          setTimeout(function () {
            if (self.userData.settings.cancelConnection) {
              self.cancelConnectInvitationsInit();
            }
          }, 1000);

          var followUpIds = false;
          if (self.followUpIds.length) {
            followUpIds = self.followUpIds;
          }

          _console.log("FOLLOW UP IDS: ", self.followUpIds);

//                    self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
//                        self.requestToServer(
//                                {
//                                    type: "POST",
//                                    url: self.domain + ":3000/api/v1/saveTotalConnects",
//                                    data: {
//                                        sessionCookie: cookie,
//                                        totalConnects: self.newTotalConnects,
//                                        updatedConnects: followUpIds
//                                    }
//                                },
//                                function (response) {
//                                    console.log('refreshLoop', response);
//
//                                    self.sendedFollowUpIds = [];
//                                    self.followUpIds = [];
//
//                                    if (response.err) {
//                                        self.showErrorNotification =
//                                                "We could not refresh your number of connections due to a server error. Try again!";
//                                        return;
//                                    }
//
//                                    self.userData.totalConnects = self.newTotalConnects;
//                                }
//                        );
//                    });
        }
      }
    };

    this.sendFollowUpsInit = function (data) {
      _console.log("FOLLOW DATA: ", data);

      self.processing = true;

      self.quickParseUserConnections(null, function (resp) {
        self.action = "refresh";
        self.rcCounter = 0;
        self.refreshArr = [];
        self.foundConnectsArr = [];

        for (var i = 0; i < data.length; i++) {
          _console.log("CHECKED: ", data[i].memberData.name, data[i].checked);

          self.followUpIds.push(data[i].memberData.id);

          if (data[i].checked || data[i].tagsList != "false") {
            self.refreshData.push(data[i]);
          }
        }

        self.connectsOffset = self.refreshData.length;

        _console.log("NEW FOLLOW DATA: ", self.refreshData);

        self.refreshLoop();
      });
    };

    this.sendFollowUpMessage = function (memberData, fum, mainCallback) {
      function _getFirstName(callback) {
        _console.log("CHECK AUTHTOKEN: ", memberData.authToken);
        if (memberData.authToken) {
          $.ajax({
            type: "GET",
            url:
                "https://www.linkedin.com/sales/profile/" +
                memberData.id +
                "," +
                memberData.authToken +
                "," +
                memberData.authType +
                "/pathfinder",
            dataType: "json",
            success: function (response) {
              _console.log(response);

              callback(response.viewee.firstName);
            },
            error: function (err) {
              _console.log(err);

              callback(false);
            }
          });
        } else {
          callback(false);
        }
      }

      var subject = "",
          body = "",
          formData = {};

      function _send() {
        chrome.cookies.get(
            {
              url:
                  "https://www.linkedin.com/wvmx/profile?trk=nav_responsive_sub_nav_wvmp",
              name: "JSESSIONID"
            },
            function (cookie) {
              self.csrfToken = cookie.value.substring(1, cookie.value.length - 1);
              self.csrfToken = cookie.value.slice(1, -1);

              $.ajax({
                type: "POST",
                url: "https://www.linkedin.com/msgToConns?displayCreate=",
                data: formData,
                success: function (response) {
                  _console.log("message sent");

                  mainCallback(true);
                },
                error: function (err) {
                  _console.log(err);

                  _clearVarsForRefresh("stop");
                  self.processing = false;
                  self.showErrorNotification =
                      "Looks like our server hiccupped! We will get right on it, but in the" +
                      " meantime try sending those messages again.";
                }
              });
            }
        );
      }

      _getFirstName(function (name) {
        _console.log("NAME: ", name);

        if (name) {
          subject = fum.s.replace(/%firstname%/g, name);
          body = fum.b.replace(/%firstname%/g, name);
        } else {
          subject = fum.s.replace(/%firstname%/g, memberData.name);
          body = fum.b.replace(/%firstname%/g, memberData.name);
        }

        formData = {
          ajaxSubmit: "Send Message",
          subject: subject,
          body: body,
          showRecipients: "showRecipients",
          connectionIds: memberData.id,
          connectionNames: "",
          allowEditRcpts: "true",
          addMoreRcpts: "false",
          itemID: "",
          openSocialAppBodySuffix: "",
          st: "",
          viewerDestinationUrl: "",
          csrfToken: self.csrfToken
        };

        _send();
      });
    };

    this.addTags = function (memberId, tags, callback) {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/saveTagsForUserConnection",
              data: {
                sessionCookie: cookie,
                memberId: [memberId],
                tags: tags
              }
            },
            function (response) {
              _console.log("tags response: ", response);

              if (response.err) {
                self.showErrorNotification =
                    "We could not add tags to connection due to a server error. Try again!";
              }

              _console.log("tags added: ", tags);

              callback(true);
            }
        );
      });
    };

    this.getUserConnects = function (data, callback) {
      $.ajax({
        type: "GET",
        url: "https://www.linkedin.com/connected/api/v2/contacts",
        data: data,
        dataType: "json",
        success: function (response) {
          _console.log(response);

          callback(response);
        },
        error: function (err) {
          _console.log("GET CONNECTS ERROR: ", err);

          callback({err: err});

          _clearVarsForRefresh("stop");
          self.processing = false;
          self.showErrorNotification =
              "Hmm... LinkedIn responded unexpectedly. Please, try again!";
        }
      });
    };

    this.quickParseUserConnections = function (sendResponse, callback) {
      callback = callback || function () {};

      var dateNow = new Date().getTime();

      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        $.get(self.domain + ":3000/api/v1/connections", {
          session_cookie: cookie,
          skip: 0,
          limit: 1,
          sort_field: "-connectionDate"
        })
            .done(function (response) {
              _console.log("QUICK RESPONSE: ", response);

              if (response.total == 0) {
                callback(true);

                if (sendResponse) {
                  sendResponse("No data in DB");
                }
                return false;
              }

              var lastConnect = response.data[0],
                  parseData = self.connectsParseData,
                  iteration = 0,
                  finded = false;

              _console.log(lastConnect);

              function _getConnections() {
                var newConnects = {};

                $.get(
                    "https://www.linkedin.com/connected/api/v2/contacts",
                    self.connectsParseData
                )
                    .done(function (response) {
                      response.values.forEach(function (val, i) {
                        _console.log(
                            "check dates: ",
                            val.connectionDate > lastConnect.connectionDate
                        );

                        if (val.connectionDate > lastConnect.connectionDate) {
                          _console.log(
                              "Finded new one:",
                              val.name,
                              val.connectionDate,
                              val.graphDistance
                          );

                          if (val.graphDistance == "DISTANCE_1") {
                            var infoObj = {};

                            infoObj.connectionDate = val.connectionDate;
                            infoObj.name = val.name;
                            infoObj.firstName = val.firstName;
                            infoObj.lastName = val.lastName;
                            infoObj.lastName = val.lastName;

                            infoObj.emails = val.emails;
                            infoObj.phoneNumbers = val.phoneNumbers;

                            if (val.company) {
                              if (val.company.name) {
                                infoObj.company = val.company.name;
                              } else if (val.company.companyName) {
                                infoObj.company = val.company.companyName;
                              }
                            }

                            if (val.title) {
                              infoObj.position = val.title;
                            }

                            if (val.location) {
                              infoObj.location = val.location;
                            }

                            infoObj.profileImageUrl = val.profileImageUrl;
                            infoObj.profileUrl = val.profileUrl;
                            infoObj.deleted = false;
                            infoObj.parseTime = dateNow;

                            newConnects[val.memberId] = infoObj;
                          }
                        }
                      });

                      _console.log(
                          "NEW: ",
                          $.isEmptyObject(newConnects),
                          newConnects
                      );

                      if (!$.isEmptyObject(newConnects)) {
                        _console.log("BEFORE REQUEST");

                        var timeout =
                            Math.floor(1 + Math.random() * (10 - 1)) * 1000;

                        self.saveUserConnections(false, "quickRefresh", newConnects, dateNow, function (resp) {
                              _console.log("SAVED");

                              iteration++;
                              parseData.start += response.values.length;

                              setTimeout(function () {
                                _getConnections();
                              }, timeout);
                            }
                        );
                      } else {
                        if (sendResponse) {
                          sendResponse("finished");
                        }

                        callback(true);
                      }
                    })
                    .error(function (err) {
                      _console.log(err);

                      if (sendResponse) {
                        sendResponse("finished");
                      }

                      callback(true);
                    });
              }

              _getConnections();
            })
            .error(function (err) {
              _console.log(err);
            });
      });
    };

    this.parseConnectionsProgress = false;
    this.interruptConnectionsProgress = false;
    this.totalConnects = 0;
    this.counterConnectsProgress = 0;

    this.parseUserConnections = function (sendResponse) {
      if (self.interruptConnectionsProgress) {
        self.parseConnectionsProgress = false;
        _console.log("interrupt detected");

        self.interruptConnectionsProgress = false;
        console.log('fullRefreshInterrupted');
        chrome.runtime.sendMessage({
          action: "fullRefreshInterrupted"
        });

        return false;
      }

      if (!self.parseConnectionsProgress) {
        self.counterConnectsProgress = 0;
        self.parseTime = new Date().getTime();
      }

      self.getUserConnects(self.connectsParseData, function (response) {
        _console.log("CONNECTIONS RESPONSE: ", response);

        if (response.err) {
          if (self.parseErrCounter < 5) {
            self.parseErrCounter++;

            var timeout = Math.floor(5 + Math.random() * (10 - 5)) * 1000;

            setTimeout(function () {
              self.parseUserConnections(sendResponse);
            }, timeout);
          } else {
            self.parseErrCounter = 0;
            self.cancelParseUserConnections(sendResponse);
          }

          return;
        }

        if (response.values.length) {
          $.get(
              "https://www.linkedin.com/connected/api/v1/contacts/connections-only-count",
              function (totalResponse) {
                self.totalConnects = totalResponse.total;

                /*var count = 50;
                 if (totalResponse.total < count) {
                 self.connectsParseData.count = totalResponse.total;
                 count = totalResponse.total;

                 } else {
                 self.connectsParseData.count = 50;
                 }

                 _console.log('PARSE DATA: ', totalResponse.total, count, self.connectsParseData);*/

                // start

                if (!self.parseConnectionsProgress) {
                  self.parseConnectionsProgress = true;
                  sendResponse({
                    action: "start",
                    total: self.totalConnects
                  });
                  chrome.runtime.sendMessage({
                    action: "fullRefreshStarted",
                    total: self.totalConnects
                  });
                }

                _console.log("RESP: ", response.values.length);

                var data = response.values,
                    infoObj = {};

                for (var i = 0; i < data.length; i++) {
                  if (data[i].graphDistance == "DISTANCE_1") {
                    _console.log(
                        "FIRST AND LAST NAME: ",
                        data[i].firstName,
                        data[i].lastName
                    );

                    infoObj.connectionDate = data[i].connectionDate;
                    infoObj.name = data[i].name;
                    infoObj.firstName = data[i].firstName;
                    infoObj.lastName = data[i].lastName;
                    _console.log(data[i]);

                    infoObj.emails = data[i].emails;
                    infoObj.phoneNumbers = data[i].phoneNumbers;

                    if (data[i].company) {
                      if (data[i].company.name) {
                        infoObj.company = data[i].company.name;
                      } else if (data[i].company.companyName) {
                        infoObj.company = data[i].company.companyName;
                      }
                    }

                    if (data[i].title) {
                      infoObj.position = data[i].title;
                    }

                    if (data[i].location) {
                      infoObj.location = data[i].location;
                    }

                    infoObj.profileImageUrl = data[i].profileImageUrl;
                    infoObj.profileUrl = data[i].profileUrl;
                    infoObj.deleted = false;
                    infoObj.parseTime = self.parseTime;

                    self.userConnections[data[i].memberId] = infoObj;
                    infoObj = {};
                  }
                }

                self.saveUserConnections(false, "fullRefresh", self.userConnections, self.parseTime, function (resp) {
                  // update

                  self.counterConnectsProgress += Object.keys(
                      self.userConnections
                  ).length;

                  chrome.runtime.sendMessage({
                    action: "fullRefreshUpdated",
                    value: self.counterConnectsProgress,
                    total: self.totalConnects
                  });

                  self.userConnections = {};
                  self.connectsParseData.start += 50;

                  var timeout = Math.floor(5 + Math.random() * (10 - 5)) * 1000;

                  setTimeout(function () {
                    self.parseUserConnections(sendResponse);
                  }, timeout);
                });
              }
          );
        } else {
          _console.log("STOP");

          // finish
          self.parseConnectionsProgress = false;
          self.connectsParseData.start = 0;
          //sendResponse('finished');
          chrome.runtime.sendMessage({
            action: "fullRefreshStoped"
          });

          self.checkDeletedConnections(self.parseTime, function (resp) {
            self.parseTime = 0;
          });
        }
      });
    };

    this.cancelParseUserConnections = function (sendResponse) {
      self.interruptConnectionsProgress = true;
      sendResponse("cancelRefresh");
    };

    this.checkParseUserConnections = function () {
      return self.parseConnectionsProgress;
    };

    this.saveUserConnections = function (
        firstPortion,
        type,
        userConnections,
        parseTime,
        callback
    ) {
      _console.log("DATA: ", type, userConnections, parseTime);

      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        _console.log("cookie: ", cookie);

        self.requestToServer(
            {
              type: "PUT",
              url: self.domain + ":3000/api/v1/saveUserConnections",
              data: {
                firstPortion: firstPortion,
                sessionCookie: cookie,
                type: type,
                connections: userConnections,
                parseTime: parseTime
              }
            },
            function (response) {
              _console.log("SAVE UC RESP: ", response);

              if (response.err) {
                self.showErrorNotification =
                    "We could not save your connections due to a server error. Try again!";

                return;
              }

              callback(true);
            }
        );
      });
    };

    this.checkDeletedConnections = function (parseTime, callback) {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/checkDeletedConnections",
              data: {
                sessionCookie: cookie,
                parseTime: parseTime
              }
            },
            function (response) {
              _console.log(response);

              callback(true);

              if (response.err) {
                self.showErrorNotification =
                    "We could not check deleted connections due to a server error. Try again!";

                return;
              }
            }
        );
      });
    };

    function _saveTotalConnects(total) {
      //chrome.storage.local.set({totalConnects: total}, function (value) {
//            self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
//                self.requestToServer(
//                        {
//                            type: "POST",
//                            url: self.domain + ":3000/api/v1/saveTotalConnects",
//                            data: {
//                                sessionCookie: cookie,
//                                totalConnects: total,
//                                updatedConnects: false
//                            }
//                        },
//                        function (response) {
//                            console.log('_saveTotalConnects', response);
//
////                            if (response.err) {
////                                                                        self.showErrorNotification = "We could not refresh your number of connections due to a server error. Try again!";
////                            }
////
////                            self.savingTotalInit = false;
////                            self.userData.totalConnects = self.newTotalConnects;
//                        }
//                );
//            });
      //});
    }

    this.checkTotalConnects = function (type, callback) {
      callback = callback || function () {};

      $.ajax({
        type: "GET",
        url:
            "https://www.linkedin.com/connected/api/v1/contacts/connections-only-count",
        data: self.fumData,
        dataType: "json",
        success: function (response) {
          _console.log(response);

          _console.log("resp total: ", response.total);

          if (type == "get") {
            callback(response.total);
          } else {
            _saveTotalConnects(response.total);
          }
        },
        error: function (err) {
          _console.log(err);

          _saveTotalConnects(0);
        }
      });
    };

    this.cancelSubscription = function () {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        _console.log("cookie: ", cookie);

        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/cancelSubscription",
              data: {sessionCookie: cookie}
            },
            function (response) {
              _console.log(response);

              if (response.err) {
                self.showErrorNotification =
                    "Submit your subscription cancellation request again, we had an" +
                    " error on our end. Thanks for understanding!";
              }
            }
        );
      });
    };

    this.getPayments = function (sendResponse) {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        _console.log("cookie: ", cookie);

        self.requestToServer(
            {
              type: "GET",
              url: self.domain + ":3000/api/v1/getPayments",
              data: {sessionCookie: cookie}
            },
            function (response) {
              _console.log("payments: ", response);

              var resp;

              if (response.err) {
                resp = {};
                self.showErrorNotification =
                    "Submit your information again, we had an error on our end. Thanks for understanding!";
              } else if (!$.isEmptyObject(response.data)) {
                resp = response.data.content;
              } else {
                resp = {};
              }

              sendResponse(resp);
            }
        );
      });
    };

    this.checkPromoCode = function (promoCode, sendResponse) {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        _console.log("cookie: ", cookie);

        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/checkPromoCode",
              data: {sessionCookie: cookie, promoCode: promoCode}
            },
            function (response) {
              _console.log("promo response: ", response);

              var resp;

              if (response.err) {
                resp = {err: true};
                self.showErrorNotification =
                    "Submit your information again, we had an error on our end. Thanks for understanding!";
              } else {
                resp = response.data.content;
              }

              sendResponse(resp);
            }
        );
      });
    };

    this.checkCouponCode = function (couponCode, sendResponse) {
      self.getCookie("https://www.linkedin.com", "li_at", function (cookie) {
        _console.log("cookie: ", cookie);

        self.requestToServer(
            {
              type: "POST",
              url: self.domain + ":3000/api/v1/checkCouponCode",
              data: {sessionCookie: cookie, couponCode: couponCode}
            },
            function (response) {
              _console.log("coupon response: ", response);

              var resp;

              if (response.err) {
                self.showErrorNotification =
                    "Submit your information again, we had an error on our end. Thanks for understanding!";
              } else {
                resp = response.data.content;
              }

              sendResponse(resp);
            }
        );
      });
    };

    this.stopProcessFunc = function (type, cb) {
      var _this = this;

      if (type == "visit" || type == "connect" || type == "offer") {
        self.processing = false;
        self.sendCounter = "Searching...";
        _updateVisitedIds("stop");
        self.action = null;
        self.sendToSrvDataArr = [];
        _clearVarsForMainProcessing();
        type = true;
      } else if (type == "refresh") {
        self.action = null;
        self.processing = false;
        self.foundConnectsArr = [];
        _clearVarsForRefresh("stop");
        type = true;
      } else if (type == "cancel") {
        //self.action = null;
        _this.cancelProcessing();
        type = true;
      }

      if (type === true && typeof cb == "function") {
        cb();
      }
    };

    this.stopAllProcesses = function (sendResponse) {
      chrome.windows.getAll({populate: true}, function (windows) {
        _console.log("WINDOWS: ", windows);

        for (var i = 0; i < windows.length; i++) {
          if (
              windows[i].tabs.length == 1 &&
              windows[i].tabs[0].title == "Stripe payment"
          ) {
            chrome.tabs.remove(windows[i].tabs[0].id, function (resp) {});
          }
        }
      });

      sendResponse = sendResponse || function () {};

      _console.log("STOP ALL");

      if (linkeleadModel.checkParseUserConnections()) {
        linkeleadModel.cancelParseUserConnections(sendResponse);
        sendResponse("cancelRefresh");
      } else {
        linkeleadModel.sendMessageToConnections(
            "canceledMessaging",
            sendResponse
        );
      }

      self.action = null;
      self.processing = false;
      _clearVarsForMainProcessing();
      _clearVarsForRefresh("end");
      self.cancelProcessing();
    };

    this.getUserData = function (sendResponse) {
      linkeleadModel.checkSession(false, function (response) {
        //_console.log(response);

        chrome.storage.local.get("userInfo", function (storage) {
          _console.log("USER INFO: ", storage);
          sendResponse(response);
        });

        //sendResponse(response);
      });
    };

    /**
     *
     * @param {Object} data: {
     *   connectionIds: {Array of int},
     *   subject: {String},
     *   body: {String}
     * }
     * @param sendResponse
     */
    this.sendMessageToConnections = function (data, sendResponse) {
      var _this = this;

      if (data === "canceledMessaging") {
        _this.descCount = -1;
        _console.log("Canceleddd");
        sendResponse("canceled");
        return false;
      } else if (data === "canceledMessagingByError") {
        _this.descCount = -1;
        _console.log("Canceleddd by error");
        chrome.runtime.sendMessage({
          action: "erroredMessaging"
        });
        return false;
      } else if (data === "checkMessagingProcess") {
        if (_this.descCount > 0) {
          sendResponse({
            total: _this.total,
            i: _this.i
          });
        } else {
          sendResponse(false);
        }

        return false;
      } else {
        this.descCount = 0;
        this.i = 0;
        this.total = data.connectionIds.length;

        chrome.cookies.get(
            {
              url:
                  "https://www.linkedin.com/wvmx/profile?trk=nav_responsive_sub_nav_wvmp",
              name: "JSESSIONID"
            },
            function (cookie) {
              _this.descCount = data.connectionIds.length;

              _console.log("Sending started");
              // Alert tab that we started messaging
              sendResponse(data.connectionIds.length);

              _sendMessageLoop();

              function _sendMessageLoop() {
                var rndTime = Math.random() * (15 - 5) + 5;

                _console.log("rndTime", rndTime);

                if (_this.descCount > 0) {
                  console.log('fsdfsfsdf123123');
                  setTimeout(function () {
                    // Alert tab that we sent some message

                    _console.log(_this.descCount);

                    if (_this.descCount !== -1) {
                      _console.log("length of total", data.connectionIds.length);

                      chrome.runtime.sendMessage({
                        action: "updateMessaging",
                        i: _this.i,
                        total: data.connectionIds.length
                      });

                      var formData = {
                        ajaxSubmit: "Send Message",
                        subject: data.subject.replace(
                            /%firstname%/g,
                            data.connectionIds[_this.i][1]
                        ),
                        body: data.body.replace(
                            /%firstname%/g,
                            data.connectionIds[_this.i][1]
                        ),
                        showRecipeints: "showRecipeints",
                        connectionIds: data.connectionIds[_this.i][0],
                        connectionNames: "",
                        allowEditRcpts: "true",
                        addMoreRcpts: "false",
                        itemID: "",
                        openSocialAppBodySuffix: "",
                        st: "",
                        viewerDestinationUrl: "",
                        csrfToken: cookie.value.slice(1, -1)
                      };

                      $.ajax({
                        type: "POST",
                        url: "https://www.linkedin.com/msgToConns?displayCreate=",
                        data: formData,
                        success: function (response) {
                          _console.log(response);

                          $.ajax({
                            type: "POST",
                            url: self.domain + ":3000/api/v1/saveLastMessage",
                            data: {
                              sessionCookie: linkeleadModel.sessionCookie,
                              memberId: formData.connectionIds
                            }
                          });

                          sendResponse(response);
                          _console.log(
                              "message sent to " + data.connectionIds[_this.i - 1]
                          );
                        },
                        error: function (err) {
                          _console.log(err);
                          sendResponse(err);

                          linkeleadModel.sendMessageToConnections(
                              "canceledMessagingByError"
                          );

                          _console.log(
                              "can't sent message to " +
                              data.connectionIds[_this.i - 1]
                          );
                        }
                      });

                      _this.descCount--;
                      if (_this.descCount == -1) {
                        _console.log("wtf");
                      }
                      _this.i++;
                      _sendMessageLoop();
                    }
                  }, rndTime * 1000);
                } else {
                  _console.log(_this.descCount);

                  if (_this.descCount !== -1) {
                    _console.log("Sending finished");

                    // Alert tab that we finished messaging
                    chrome.runtime.sendMessage({
                      action: "stopMessaging"
                    });
                  }

                  return false;
                }
              }
            }
        );
      }
    };

    this.getToken = function (sendResponse) {
      chrome.cookies.get(
          {
            url:
                "https://www.linkedin.com/wvmx/profile?trk=nav_responsive_sub_nav_wvmp",
            name: "JSESSIONID"
          },
          function (cookie) {
            sendResponse(cookie.value.slice(1, -1));
          }
      );
    };

    this.generateState = function () {
      function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
      }

      return s4() + s4() + s4() + s4() + s4() + s4() + s4() + s4();
    };

    this.removeDuplicateMembers = function () {
      var duplicates = [];
      var newArray = [];
      var currentId = 0;
      for (var i = 0; i < self.visitArr.length; i++) {
        currentId = self.visitArr[i].memberId;
        if (duplicates.indexOf(currentId) == -1) {
          duplicates.push(currentId);
          newArray.push(self.visitArr[i]);
        }
      }
      self.visitArr = newArray;
    };
  }

  var linkeleadModel = new LinkeleadModel();

  window.onerror = function (err) {
    linkeleadModel.stopProcessFunc(linkeleadModel.action);
  };

  chrome.browserAction.onClicked.addListener(function (tab) {
    //console.log(window.location.href.indexOf("https://www.linkedin.com/sales"), tab);

    var redirectUrl = "https://www.linkedin.com/sales/search/people";
    console.log("redirectUrl", redirectUrl);
    chrome.tabs.update(tab.id, {url: redirectUrl});

    linkeleadModel.checkSession(false, function (response) {
      if (response && !$.isEmptyObject(response)) {
//                chrome.tabs.update(tab.id, {url: redirectUrl});
        linkeleadModel.saveGAClientId();
      } else {
        linkeleadModel.saveCurrentTab(function () {
          console.log(
              linkeleadModel.oauthRedirectUri,
              linkeleadModel.generateState()
          );
          chrome.storage.local.get("memberId", function (val) {
            var session_cookie = "";
            var url =
                "https://www.linkedin.com/oauth/v2/authorization?response_type=code&client_id=" +
                linkeleadModel.oauthClientId +
                "&redirect_uri=" +
                linkeleadModel.oauthRedirectUri +
                "&state=" +
                linkeleadModel.generateState() +
                "&scope=r_liteprofile%20r_emailaddress",
                popup = window.open(
                    url,
                    "yii_eauth_popup",
                    "width=500px, height=650px ,left=0, top=0," +
                    "resizable=yes,scrollbars=no,toolbar=no,menubar=no,location=no,directories=no,status=yes"
                );
            popup.focus();
          });
        });
      }
    });
  });

  chrome.runtime.onInstalled.addListener(function (tab) {
    // _ga-first  this is our cookie, which keeps a value GA before installing ext
    chrome.cookies.get({url: 'http://linkelead.com', name: '_ga'}, function (gaClientId) {
      chrome.cookies.get({url: 'http://linkelead.com', name: '_ga-first'}, function (gaFirst) {
        if (!gaFirst) {
          var value = gaClientId ? gaClientId.value : null;
          var cidParts = value ? value.split('.') : null;
          var clientId = cidParts ? cidParts[2] + '.' + cidParts[3] : null;

          chrome.cookies.set({
            url: "http://linkelead.com",
            name: "_ga-first",
            value: clientId
          }, function (value) {
            console.log(value)
          });
        }
        chrome.tabs.create({
          url: "http://linkelead.com/welcome.html"}, function (tab) {
          console.log("New tab launched with linkelead.com/welcome.html");
        });
        chrome.tabs.create({
          url: "https://www.linkedin.com/sales/search/people",
          //url: 'back-angular/dist/index.html#/user/connections',
          active: true
        });

      })
    });

    linkeleadModel.checkSession(false, function (response) {
      if (response && !$.isEmptyObject(response)) {
        // linkeleadModel.checkUserAfterAuth()

      } else {
        linkeleadModel.saveCurrentTab(function () {
          console.log(
              linkeleadModel.oauthRedirectUri,
              linkeleadModel.generateState()
          );
          chrome.storage.local.get("memberId", function (val) {
            var session_cookie = "";
            var url =
                "https://www.linkedin.com/oauth/v2/authorization?response_type=code&client_id=" +
                linkeleadModel.oauthClientId +
                "&redirect_uri=" +
                linkeleadModel.oauthRedirectUri +
                "&state=" +
                linkeleadModel.generateState() +
                "&scope=r_liteprofile%20r_emailaddress",
                popup = window.open(
                    url,
                    "yii_eauth_popup",
                    "width=500px, height=650px ,left=0, top=0," +
                    "resizable=yes,scrollbars=no,toolbar=no,menubar=no,location=no,directories=no,status=yes"
                );
            popup.focus();
          });
        });
      }
    });
  });
  //linkeleadModel.parseUserConnections(sendResponse);

  var iconStatus = setInterval(function () {

  }, 1000);

  chrome.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {
    if (tab.url.indexOf('https://www.linkedin.com/sales/search') !== -1) {
      console.log('tab update!');
      linkeleadModel.searchUrl = tab.url;
      linkeleadModel.makeSearch(function () {

      });
    }
  });

  chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    console.log('listener 1', request.action);
    console.log('listener 2', request);

    if (request.action === "saveCurrentTab") {
      linkeleadModel.saveCurrentTab(sendResponse);
    } else if (request.action === "reloadActiveTab") {
      linkeleadModel.reloadActiveTab(sendResponse);
      ga('send', 'event', 'reloadActiveTab', 'click');
    } else if (request.action === "checkUserAfterAuth") {
      linkeleadModel.checkUserAfterAuth(request.id, sendResponse);
      ga('send', 'event', 'checkUserAfterAuth', 'click');
    } else if (request.action === "session") {
      linkeleadModel.checkSession(request.login, sendResponse);
    } else if (request.action === "getPlanInfo") {
      linkeleadModel.getPlanInfo(sendResponse);
    } else if (request.action === "processingStatus") {
      linkeleadModel.checkProcessing(sendResponse);
    } else if (request.action === "getUserId") {
      _console.log(linkeleadModel.userData.userId);
      if (!linkeleadModel.userData.userId) {
        linkeleadModel.checkSession(false, function () {
          sendResponse(linkeleadModel.userData.userId);
        });
      } else {
        sendResponse(linkeleadModel.userData.userId);
      }
    } else if (request.action === "processing") {
      linkeleadModel.setValues(
          request.type,
          request.searchUrl,
          request.options,
          request.design,
          sendResponse
      );
    } else if (request.action === "getSettings") {
      linkeleadModel.getUserSettings(sendResponse);
    } else if (request.action === "saveSettings") {
      linkeleadModel.updateUserSettings(request.settings, sendResponse);
    } else if (request.action === "saveNotifications") {
      linkeleadModel.updateNotifications(request.notifications, sendResponse);
    } else if (request.action === "submitStripeForm") {
      linkeleadModel.submitStripeForm(
          request.data,
          request.coupon,
          sendResponse
      );
    } else if (request.action === "refresh") {
      linkeleadModel.refreshConnectsInit(sendResponse);
    } else if (request.action === "cancelSubscription") {
      linkeleadModel.cancelSubscription();
    } else if (request.action === "getPayments") {
      linkeleadModel.getPayments(sendResponse);
    } else if (request.action === "changeCancelConnectsStatus") {
      linkeleadModel.userData.settings.cancelConnection = request.checked;
    } else if (request.action === "getInMailCredits") {
      console.log('dfjghkushfguksd', sender);
      linkeleadModel.searchForInMailCredits(request.url, sendResponse);
    } else if (request.action === "promoCode") {
      linkeleadModel.checkPromoCode(request.promoCode, sendResponse);
    } else if (request.action === "couponCode") {
      linkeleadModel.checkCouponCode(request.couponCode, sendResponse);
    } else if (request.action === "stop_progress") {
      linkeleadModel.stopProcessFunc(request.type, sendResponse);
    } else if (request.action === "stopAllProcesses") {
      linkeleadModel.stopAllProcesses();
    } else if (request.action === "getUserData") {
      linkeleadModel.getUserData(sendResponse);
      ga('send', 'event', 'getUserData', 'click');
    } else if (request.action === "sendMessageToConnections") {
      linkeleadModel.sendMessageToConnections(request.data, sendResponse);
      ga('send', 'event', 'sendMessageToConnections', 'click');
    } else if (request.action === "cancelMessaging") {
      if (linkeleadModel.checkParseUserConnections()) {
        linkeleadModel.cancelParseUserConnections(sendResponse);
        sendResponse("cancelRefresh");
      } else {
        linkeleadModel.sendMessageToConnections(
            "canceledMessaging",
            sendResponse
        );
      }
    } else if (request.action == "checkMessagingProcess") {
      linkeleadModel.sendMessageToConnections(
          "checkMessagingProcess",
          sendResponse
      );
    } else if (request.action == "getSessionCookie") {
      _console.log(linkeleadModel.sessionCookie);
      sendResponse(linkeleadModel.sessionCookie);
    } else if (request.action == "makeFullRefresh") {
      linkeleadModel.parseUserConnections(sendResponse);
      ga('send', 'event', 'makeFullRefresh', 'click');
    } else if (request.action == "makeFastRefresh") {
      linkeleadModel.quickParseUserConnections(sendResponse);
      ga('send', 'event', 'makeFastRefresh', 'click');
    } else if (request.action == "sendFollowUps") {
      linkeleadModel.sendFollowUpsInit(request.data);
      ga('send', 'event', 'sendFollowUps', 'click');
    } else if (request.action == "getToken") {
      linkeleadModel.getToken(sendResponse);
    } else if (request.action == "goCrm") {
      chrome.tabs.create({
        url: "back-angular/dist/index.html#/user/connections",
        active: true
      });
      ga('send', 'event', 'goCrm', 'click');
    } else if (request.action == "errorTest") {
      linkeleadModel.updateerrcounter();
    } else if (request.action == "goSales") {
      chrome.tabs.create({
        url: "https://www.linkedin.com/sales/search",
        active: true
      });
      ga('send', 'event', 'goSales', 'click');
      // after autorization in LinkedIn
      linkeleadModel.saveGAClientId();
    } else if (request.action == "checkProcessingLinSearch") {
      linkeleadModel.checkProcessingLinSearch(sendResponse);
    } else if (request.action == "stop_progressLinkedSearch") {
      linkeleadModel.stop_progressLinkedSearch(request, sendResponse);
    } else if (request.action == "saveCountClickSailse") {
      linkeleadModel.saveCountClickSailse(request, sendResponse);
    }

    return true;
  });
})(jQuery);
