$(function (e) {
    var click = false;
    log("point 1");
    /* Send message to background page */

    chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {


    });


    this.sendMessageToBG = function (options, callback) {

        callback = callback || function (err) {

        };

        chrome.runtime.sendMessage(options, function (response) {

            callback(response);
        });
    };

    /* main menu */

    /* hide popup */
    $(document).on('click', '.ll-ext-popup-btn.cancel-btn', function (e) {
        e.preventDefault();
        hidePopup($(this).closest('.ll-ext-popup'));
        $('.ll-ext-btn-list [data-popup]').removeClass('active');
    });

    /* send connect */
    $(document).on("click", "#connect-popup .ll-ext-popup-btn.start-btn", function (e) {
        e.preventDefault();
    });
    /* send visit */
    $(document).on('click', '#visit-popup .ll-ext-popup-btn.start-btn', function (e) {
        e.preventDefault();
    });

    //
    /* Check information about user */
    this.checkUser = function () {
        log("checkUser");
        self.sendMessageToBG({action: 'session', login: false}, function (user) {

            if (!user || user.err) {
                alertify.notify('Connection error. Please try again in a few minutes.', 'error', 5);
                return;
            } else if (!$.isEmptyObject(user)) {
                // Check for user subscription or expiration date
                if (!(user.expirationDate > new Date().getTime() / 1000 || user.promoCode > new Date().getTime() / 1000)) {
                    _addPaymentWrap();
                }
            }
        });
    };

    function _addPaymentWrap() {
        if (typeof ($(".ext-btn-wrap.btn-wrap-new.ll-ext-btn-wrapper")) !== "undefined") {
            if ($(".ext-btn-wrap.btn-wrap-new.ll-ext-btn-wrapper").length < 1) {
                $('.search-results__primary-cluster').prepend($(self.html.addPaymentWrap));
                var images_url = chrome.extension.getURL("images/");
                notifi_loading_path = images_url;
                $(".chose-plan-btn").on("click", function () {
                    chrome.runtime.sendMessage({action: "goCrm"});
                });
                setTimeout(_addPaymentWrap, 1000);
            }
        }
    }

    /* -------------------------------------------------------------------------------------------------------------------------------------------------------------- */
    this.saveNotifications = function () {
        log("saveNotifications");

        self.sendMessageToBG({action: 'saveNotifications', notifications: self.notifications}, function (cb) {

            notificationsListLinked();
        });
    };

    function checkProcessingLinked() {

        setTimeout(function () {
            log('checkProcessingLinked');
            self.sendMessageToBG({
                action: 'checkProcessingLinSearch',
            }, function (response) {


                if (response.status) {
                    self.notifications = {
                        "progress_value": response.progress_value,
                        "progress_type": response.progress_type,
                        "progress_status": response.progress_status
                    };
                    $("#notification_new_list").css("display", "block");
                    if (response.progress_status === "Done" || response.progress_status === "Cancelled") {
                        self.saveNotifications();
                    }
                    self.addProgressBarLinked(response.progressInfo, self.notifications);
                    checkProcessingLinked();


                } else {
                    //$(".ll-ext-notifications").css("display", "block");
                    //$("#process_notification").css("display", "none");

                    $("#no_the_processing").css("display", "block");
                    $("#the_processing").css("display", "none");

                    $("#notification_new_list").css("display", "block");
                    if (self.notifications.progress_status !== "Cancelled") {
                        self.notifications = {
                            "progress_value": response.progress_value,
                            "progress_type": response.progress_type,
                            "progress_status": response.progress_status
                        };
                    }
                    if (response.progress_status === "Done" || response.progress_status === "Cancelled") {
                        self.saveNotifications();
                    }
                    self.addProgressBarLinked(response.progressInfo, self.notifications);
                }

            });

        }, 1000);
    }

    function getParameterByName(name, url) {
        if (!url)
            url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(url);
        if (!results)
            return null;
        if (!results[2])
            return '';
        eval("var arrays=" + decodeURIComponent(results[2].replace(/\+/g, " ")))
        return arrays;
    }

    function sendActionToBGR(e, action) {
        e.preventDefault();

        var isUserTrialPeriod = false;

        if (!click) {

            click = true;
            log('sendActionToBGR');

            self.sendMessageToBG({action: 'session', login: false}, function (user) {


                click = false;
                user = user || {};

                var userHasSubscription = false;
                var userHasTrial = false;
                var userHasCILeft = false;

                if (user.err) {
                    return __handleLoadUserInfoError(user.err);
                } else if (!$.isEmptyObject(user)) {
                    // Check for user subscription or expiration date

                    userHasSubscription = __checkUserSubscription(user);
                    userHasTrial = __checkUserTrial(user);

                    if (userHasSubscription || userHasTrial) {
                        self.userData = user;

                        var searchargument = '';

                        if (document.location.search.indexOf("facetGeoRegion") !== -1) {
                            searchargument = "&guides=List(v-%3EPEOPLE,facetGeoRegion-%3E" + encodeURIComponent(getParameterByName('facetGeoRegion', document.location.href).join("|")) + ")";
                        } else {
                            searchargument = "&guides=List(v-%3EPEOPLE)";
                        }

                        var usrlSearch = "https://www.linkedin.com/voyager/api/search/cluster" + document.location.search + "&q=guided" + searchargument + "&count=25&start=0";


                        switch (action) {
                            case "connect":
                                if (userHasTrial) {
                                    __showTrialCIModal(user, function (usrLimit) {
                                        __handleUserConnectAction(usrlSearch, usrLimit);
                                    });
                                } else {
                                    __handleUserConnectAction(usrlSearch, $("#connect-popup .decimal").val());
                                }

                                break;

                            case "visit":

                                self.visitPageLinked(usrlSearch, {'limit': $("#visit-popup .decimal").val()});

                                $('#visit-popup .cancel-btn span').click();
                                $("#no_the_processing").css("display", "none");
                                $("#the_processing").css("display", "block");
                                checkProcessingLinked();
                                break;
                        }
                    }
                }
            });
        }

        function __showTrialCIModal(user, cb) {
            var trialCILimit = 500;
            var CILeft = trialCILimit - user.CIcount;
            var thereNoCILeft = CILeft <= 0;

            var connectPopupEl = $('#connect-popup');

            var trialPopup = $(
                '<div id="trial-popup">' +
                '<section>' +
                '<h1>In the trial mode, your number of Connection Invitations is limited to 500.' +
                '<br>To add more, please, renew the license' +
                '</h1> ' +
                '<p>You have ' + (thereNoCILeft ? 0 : CILeft) + '/' + trialCILimit + ' Connections left.</p>' +
                '<a href="#" class="trial-popup__get-pro"><span>Get unlim by 50$ per month</span></a>' +
                '</section>' +
                '</div>'
            );

            var startBtn = $('<a href="#" class="trial-popup__start-button">Not now</a>');
            var cancelBtn = $('<a href="#" class="trial-popup__cancel-button"><span></span></a>');

            connectPopupEl.append(trialPopup);
            $('#trial-popup section').append(startBtn);
            $('#trial-popup section').append(cancelBtn);

            startBtn.on('click', function (e) {
                __removePopup(e);
                if (!thereNoCILeft) {
                    cb(CILeft);
                }
            });

            cancelBtn.on('click', __removePopup);

            function __removePopup(e) {
                e.preventDefault();

                startBtn.off('click');
                cancelBtn.off('click');

                $('#trial-popup').remove();

            }
        }

        function __handleUserConnectAction(usrlSearch, usrLimit) {

//            var messageBody = $('#somemessage').val().trim() || '';
//
//
//            if (messageBody.length) { // Message body is not empty
//                if (self.textLength > 300) {
//                    $(this).css('border-color', 'red');
//                    // alertify.notify('Max length: 300 symbols.', 'error', 5);
//                    return;
//                }
//
//                var ciObj = {};
//                var tagsArr = [];
//                var fumVal = $('#somemessage2').val().trim();
//                var fum = false;
//                var tags = $(".select2-search-choice").find("div");
//
//                $(tags).each(function (index, value) { // Form list of chosen tags
//                    tagsArr.push($(value).html());
//                });
//
//                if (!tagsArr.length) {
//                    tagsArr = false;
//                }
//
//                ciObj.b = $('#somemessage').val().trim();
//                ciObj.tagsList = tagsArr;
//
//                if (fumVal == '') { // If "Follow Up Message" is true
//                    ciObj.fum = false;
//                } else { // If "Follow Up Message" is false
//
//                    if ($("#somemessage2").attr("data-subject") != undefined) {
//                        fum = $("#somemessage2").attr("data-subject");
//                    }
//
//                    ciObj.fum = {
//                        s: fum,
//                        b: fumVal
//                    };
//                }
//
//                ciObj.LinkedInSearch = true;
//                ciObj.limit = usrLimit;
//
//                self.sendConnectInvitations(usrlSearch, ciObj);
//
////                $('#connect-popup .ll-ext-error').css('display', 'none');
////                $('#connect-popup .cancel-btn span').click();
////
////                $('#visit-popup .cancel-btn span').click();
//
//                $("#somemessage").val("");
//                $("#somemessage2").val("");
//
//                $("#no_processing").css("display", "none");
//                $("#the_processing").css("display", "block");
//
//                checkProcessingLinked();
//
//            } else {
//
//                $('#connect-popup .ll-ext-error').css('display', 'block');
//                $('#somemessage').css('border-color', 'red');
//
//                return;
//            }
        }

        /**
         * Handle loading user data error. Most often it is network/auth error
         * @param {Object} err
         */
        function __handleLoadUserInfoError(err) {
            alertify.notify('Connection error. Please try again in a few minutes.', 'error', 5);

        }

        /**
         * Check if user has not expired subscription.
         * @param {Object} user
         * @returns {Boolean} - is user has not-expired subscription
         */
        function __checkUserSubscription(user) {
            return user.expirationDate > new Date().getTime() / 1000;
        }

        /**
         * Check if user has not expired trial promocode.
         * @param {Object} user
         */
        function __checkUserTrial(user) {
            return !!(user.promoCode && user.promoCode > new Date().getTime() / 1000);
        }
    }

    /* -------------------------------------------------------------------------------------------------------------------------------------------------------------- */

    /* hide error */
    $(document).on('focus', '.ll-ext-required textarea', function (e) {
        $(this).closest('.ll-ext-required').removeClass('show-error');
    });


    /* treat input */
    $(document).on('keypress', '.ll-ext-popup-treat input', function (e) {
        e = e || event;
        if (e.ctrlKey || e.altKey || e.metaKey)
            return;
        var chr = getChar(e);
        if (chr == null)
            return;
        if (chr < '0' || chr > '9') {
            return false;
        }
    });

    $(document).on('keyup', '.ll-ext-popup-treat input', function (e) {
        var $this = $(this),
            min = parseInt($this.attr('data-min')),
            max = parseInt($this.attr('data-max')),
            val = $this.val();

        if (val < min) {
            val = min;
            $this.val(val);
        } else if (val > max) {
            val = max;
            $this.val(val);
        } else if (val.substring(0, 1) == 0) {
            val = val.substring(1, 4);
            $this.val(val);
        }


        $this.closest('.ll-ext-popup').find('.ll-ext-popup-slider-val').text(val);

        $this.closest('.ll-ext-popup').find('.ll-ext-popup-slider').slider('value', val);
    });


    /* length counter */
    $(document).on('input', '.ll-ext-textarea-wrapper textarea', function (e) {
        var $this = $(this),
            length = $this.val().length;
        if ($this.closest('.ll-ext-textarea-wrapper').find('.ll-ext-maxlength').length) {
            $this.closest('.ll-ext-textarea-wrapper').find('.ll-ext-maxlength span').text(length);
        }
    });


    /* vars */
    $(document).on('click', '.ll-ext-vars a', function (e) {
        var $this = $(this),
            $textarea = $this.closest('.ll-ext-tabs-content').find('textarea'),
            val = $this.attr('data-var');

        insertAtCaret($textarea, val);

        if ($this.closest('.ll-ext-tabs-content').find('.ll-ext-maxlength').length) {
            $this.closest('.ll-ext-tabs-content').find('.ll-ext-maxlength span').text($textarea.val().length);
        }
    });


    /* tabs */
    $(document).on('click', '.ll-ext-tabs-wrapper .ll-ext-tabs-labels a', function (e) {
        e.preventDefault();
        var $this = $(this),
            index = $this.closest('.ll-ext-tabs-labels').children('a').index($this),
            $tabs = $this.closest('.ll-ext-tabs-wrapper');
        showTab($tabs, index);
    });


    /* template selection */
    $(document).on('click', '.ll-ext-template-item', function () {
        $(this).toggleClass('active').siblings('.ll-ext-template-item').removeClass('active');
    });

    /* add template */
    function _addTemplate(prefix, $elem) {
        if (prefix === 'ci') {
            var data = self.userData.settings.templates.ci;
        } else {
            var data = self.userData.settings.templates.fum;
        }
        $elem.children().remove();
        for (var i = 0; i < data.length; i++) {
            $item = self.tmpItem.clone();
            message = data[i].b;
            value = data[i].s;
            $item.html('<div class="ll-ext-template-name">' + value + '</div><div class="ll-ext-template-preview">' + message + '</div><div class="ll-ext-template-use"><span>use</span></div>');
            $item.attr('id', prefix + '-' + i);
            $item.attr('data-id', i);
            $elem.prepend($item);
        }
    }

    function _remove_ico() {
        var images_url = chrome.extension.getURL("images/");
        $(".ll-ext-popup .ll-ext-tags-wrapper .select2-search-choice .select2-search-choice-close ").css("background", "url('" + images_url + "cross.svg')  no-repeat 0 0/100% 100%");
    }

    /* add tags */
    function addNewTag(action) {
        $("#e9").select2();
        $("#e9").bind("change", _remove_ico);
        $elem = $('#e9');
        $elem.children().remove();
        for (var i = 0; i < self.userData.settings.tags.length; i++) {
            $item = self.tagItem.clone();
            $item.text(self.userData.settings.tags[i]);
            $item.attr('value', i);
            $elem.prepend($item);
        }
    }

    /* tags */
    $(document).on('click', '.ll-ext-tags', function (e) {
        log("point 3, emit click");
        notificationsListLinked();
        e.preventDefault();
        $(this).find('input').focus();
        log('addNewTag');
        self.sendMessageToBG({action: 'session', login: false}, function (user) {

            self.userData = user;
            $("#e9").select2();
            $("#e9").bind("change", _remove_ico);
            addNewTag();
            _addTemplate('ci', $('#connect-tmp-list'));
            _addTemplate('fum', $('#fum-tmp-list'));

            $("#connect-tmp-list .ll-ext-template-item .ll-ext-template-use").on("click", function () {
                $("#somemessage").empty();
                $("#somemessage").val(self.userData.settings.templates.ci[$(this).parent().data('id')].b);
                var tabs = $("#new_message").closest('.ll-ext-tabs-wrapper');
                tabs.find('.ll-ext-tabs-labels a:eq(0)').addClass('active').siblings('a').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0)').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0) .scrollbar-inner').scrollbar();
            });

            $("#fum-tmp-list .ll-ext-template-item .ll-ext-template-use").on("click", function () {
                $("#somemessage2").empty();
                $("#somemessage2").val(self.userData.settings.templates.fum[$(this).parent().data('id')].b);
                $("#somemessage2").attr("data-subject", self.userData.settings.templates.fum[$(this).parent().data('id')].s);
                var tabs = $("#new_followUp").closest('.ll-ext-tabs-wrapper');
                tabs.find('.ll-ext-tabs-labels a:eq(0)').addClass('active').siblings('a').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0)').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0) .scrollbar-inner').scrollbar();
            });
        });
    });

    $(document).on('click', '.ll-ext-tag span', function (e) {
        e.preventDefault();
        e.stopPropagation();
        $(this).closest('.ll-ext-tag').remove();
    });

    $(document).on('keydown', '.ll-ext-tags-add input', function (e) {
        var $this = $(this),
            $container = $this.closest('.scrollbar-inner');
        if (e.which == 13 && $this.val() != '') {
            e.preventDefault();

            addTag($this, $this.val());
        }

        if (e.keyCode == 8 && $this.val() == '') {
            e.preventDefault();

            $container.find('.ll-ext-tag:last').remove();
        }

        resizeTagInput($this);
    });

    $(document).on('blur', '.ll-ext-tags-add input', function (e) {
        var $this = $(this);

        if ($this.val() != '') {
            e.preventDefault();

            addTag($this, $this.val());
        }

        resizeTagInput($this);
    });

    $(window).resize(function () {
        checkPopupPosition();
    });

    function log(a) {


    }

    /* -------------------------------------------------------------------------------------------------------------------------------------------------------------- */
    // new
    /* Popup for notification pages */
    function notificationsListLinked() {
        // log("errr");
        if (document.location.href.indexOf("https://www.linkedin.com/sales/search") + 1) {
            log('notificationsListLinked');
            self.sendMessageToBG({action: 'getSettings'}, function (response) {

                $("#notification_new_list").css("display", "none");
                var notifications = response.notifications;
                if (notifications != '') {
                    for (var i = 0; i < notifications.length; i++) {
                        $('#notification_old_list').css("display", "block");
                        $('#notification-popup #notification_old_list').prepend('<div class="ll-ext-notification" data-status="' + notifications[i]["progress_status"].toLowerCase() + '"> ' +
                            '<div class="notification-number">' + notifications[i]["progress_value"] + '</div> ' +
                            '<div class="notification-text"><text>' + notifications[i]["progress_type"] + '</text> <span>' + notifications[i]["progress_status"] + '</span>' +
                            '</div> ');
                    }
                    $('#processing').hide();
                    if (parseInt($("#notification-popup").css("opacity")) != 0) {
                        // asdf
                        $(".ll-ext-btn-list [data-popup=notification-popup]:not([id=process_notification])").addClass("active");
                    } else {
                        $(".ll-ext-btn-list [data-popup=notification-popup]:not([id=process_notification])").remove("active");
                    }
                } else {
                    $('#notification_old_list').css("display", "none");
                    $('#notification-popup #notification_empty_list').remove();
                    $('#notification-popup').append('<div id="notification_empty_list" style="height:242px;display:flex;align-items: center;justify-content: center;padding: 25px;text-align: center;"></div>');
                    $('#notification-popup #notification_empty_list').prepend('<div class="ll-ext-notification" data-status=""> ' +
                        '<div class="notification-text"><text>Please start your first campaign. Enter search criteria and visit profiles or send connection invitations</text>' +
                        '</div> ');
                }

                if ($('#notification-popup #notification_old_list').length === 0) {
                    setTimeout(function () {
                        notificationsListLinked();
                    }, 1500)
                }
            });
        }
    }

    this.addProgressBarLinked = function (progressInfo, progressInfoLikedSarch) {
        var progress_bar_data = $('#notification-popup .ll-ext-notification'),
            _this = this;

        if (!$('.ext-progress-bar').length) {
            var title = '', body = '';
            $('html').append($(self.html.progressBar));

            var txt = {
                visit: {
                    title: 'Visiting profiles',
                    body: 'Please wait. \nVisiting is in process...'
                },
                connect: {
                    title: 'Sending connections',
                    body: 'Please wait...\nSending is in process...'
                },
                offer: {
                    title: 'Sending messages',
                    body: 'Please wait.\nSending is in process...'
                },
                refresh: {
                    title: 'Refreshing connects',
                    body: 'Please wait.\nRefreshing is in process...'
                },
                cancel: {
                    title: 'Canceling invitations',
                    body: 'Please wait.\nCanceling is in process...'
                }
            };

            $('.progress-bar-title').text(txt[progressInfo.action].title);
            $('.progress-bar-body').text(txt[progressInfo.action].body);

        } else {
            var percentage = 0;
            var SendStopToBG = function () {
                status_progress_cancel = true;
                try {
                    chrome.storage.local.remove('state');
                    log('SendStopToBG');
                    self.sendMessageToBG({
                        action: 'stop_progressLinkedSearch',
                        type: progressInfo.action
                    }, function (response) {

                        self.notifications = {
                            "progress_value": response.progress_value,
                            "progress_type": response.progress_type,
                            "progress_status": response.progress_status
                        };
                        $("#notification_new_list").css("display", "block");
                        if (response.progress_status === "Done" || response.progress_status === "Cancelled") {
                            //self.saveNotifications();
                        }
                    });
                } catch (err) {
                }
            };

            var progress_type_count;
            if (progressInfo.action == "visit") {
                progress_type = "Visiting Profiles";
                progress_type_count = self.userData.settings.visits_count;
            } else if (progressInfo.action == "connect") {
                progress_type = "Sending Connection Invitations";
                progress_type_count = self.userData.settings.users;
            } else if (progressInfo.action == "offer") {
                progress_type = "Sending InMails";
                progress_type_count = self.userData.settings.inmails_count;
            }
            if (progress_type_count && $('#notification-popup #notification_new_list .notification-number').text().trim() == "") {
                $('#notification-popup .scrollbar-inner #notification_new_list').prepend('<div class="ll-ext-notification new" data-status="search_progress"> ' +
                    '<div class="notification-number">0/' + progress_type_count + '</div> ' +
                    '<div class="notification-text"><text id="progress_text">' + progress_type + '</text> <span id="progress_status">Starting...</span></div> ' +
                    '</div> ');
            }
            var progress_value = -1;
            if (progressInfo.counter != progress_value) {
                progress_bar_data.data('step', 'progress');

                progress_value = +progressInfo.counter + '/' + progressInfo.limit;
                percentage = Math.floor((+progressInfo.counter) / progressInfo.limit * 1000);

                if (!$('#notification-popup .ll-ext-notification').hasClass('in_progress')) {
                    $('#notification-popup .ll-ext-notification').addClass('in_progress');
                    var _circle_progress_wrapper = $('#notification-popup .ll-ext-notification').eq(0);

                    if (_circle_progress_wrapper && _circle_progress_wrapper.length && _circle_progress_wrapper[0]) {
                        _circle_progress_wrapper = _circle_progress_wrapper[0];
                        progress_bar_pointer = new ProgressBar.Circle(_circle_progress_wrapper, {
                            step: function (state, circle) {
                                if (!progress_bar_pointer_circle) {
                                    progress_bar_pointer_circle = true;
                                    if ($('#notification-popup #notification_new_list .notification-number').text().trim() != "") {
                                        $('#notification-popup #notification_new_list .notification-number').text(progress_value);
                                        $('#notification-popup #notification_new_list .notification-text #progress_text').text(progress_type);
                                        $('#notification-popup #notification_new_list .ll-ext-notification.new ').attr('data-status', 'progress');
                                        $('#notification-popup #notification_new_list .notification-text #progress_status').text(progressInfoLikedSarch.progress_status);
                                        $('#notification-popup #notification_new_list .notification-text').append('<a href="#" class="progress-cancel">Cancel</a>');
                                    }
                                    progress_bar_pointer_circle = $('#notification-popup #notification_new_list .ll-ext-notification').find('.notification-number');
                                }
                            }
                        });
                    }
                }

                if (progress_bar_pointer) {
                    progress_bar_pointer.stop();
                    if (progress_bar_pointer_circle) {
                        progress_bar_pointer_circle.html(progress_value);
                        if (!circle_progressbar_text) {
                            circle_progressbar_text = $('#notification-popup .ll-ext-notification .notification-text .progress-cancel');
                            circle_progressbar_text.on('click', SendStopToBG);
                        }
                    }
                }
            }
        }
        // notificationsListLinked();
    };

    /* Send connect invitation to chosen contacts */
    this.sendConnectInvitations = function (searchUrl, options) {
        log('sendConnectInvitations');
        self.sendMessageToBG({
            action: 'processing',
            type: 'connect',
            searchUrl: searchUrl,
            options: options,
            design: self.design
        }, function (response) {


        });
    };
    /* Visit pages of chosen contacts */
    this.visitPageLinked = function (searchUrl, options) {
        log('visitPageLinked');
        self.sendMessageToBG({
            action: 'processing',
            type: 'visit',
            searchUrl: searchUrl,
            options: {"LinkedInSearch": true, "limit": options.limit},
            design: self.design
        }, function (response) {

        });
    };


    /* Save changes for user settings */
    this.saveChanges = function () {
        log('saveChanges');
        self.sendMessageToBG({action: 'saveSettings', settings: self.userData.settings}, function (cb) {

        });
    };


    this.html = new HTML();
    this.notifications = null;
    this.design = 1;
    this.checkInit = false;
    var progress_bar_pointer_circle = null;
    var circle_progressbar_text = null;
    this.tagItem = $(this.html.tagItem);
    this.tmpItem = $(this.html.tmpItem);

    var self = this;
    self.checkUser();

    function checkSettings() {
        log('checkSettings');
        self.sendMessageToBG({action: 'session', login: false}, function (user) {

            if (user.status) {
                self.userData = user;
            }
        });
    }

    log('session123123');
    self.sendMessageToBG({action: 'session', login: false}, function (user) {

        if (user.status) {
            self.userData = user;

            $("#connect-tmp-list .ll-ext-template-item .ll-ext-template-use").on("click", function () {
                $("#somemessage").empty();
                $("#somemessage").val(response.settings.templates.ci[$(this).parent().data('id')].b);
                var tabs = $("#new_message").closest('.ll-ext-tabs-wrapper');
                tabs.find('.ll-ext-tabs-labels a:eq(0)').addClass('active').siblings('a').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0)').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0) .scrollbar-inner').scrollbar();
            });

            $("#fum-tmp-list .ll-ext-template-item .ll-ext-template-use").on("click", function () {
                $("#somemessage2").empty();
                $("#somemessage2").val(response.settings.templates.fum[$(this).parent().data('id')].b);
                $("#somemessage2").attr("data-subject", response.settings.templates.fum[$(this).parent().data('id')].s);
                var tabs = $("#new_followUp").closest('.ll-ext-tabs-wrapper');
                tabs.find('.ll-ext-tabs-labels a:eq(0)').addClass('active').siblings('a').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0)').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');
                tabs.find('.ll-ext-tabs-content:eq(0) .scrollbar-inner').scrollbar();
            });

            $('body').on('keyup', '.select2-input', function (e) {// Add new tag inside tag-list

                var $tagInput = $('.select2-input'), findSameTag = false;
                if ($tagInput.val().trim() != '' && !$.isEmptyObject(self.userData.settings)) {
                    if ($('#e9').find('.no-data').length) { // Show message about no tags
                        $('#e9').find('.no-data').remove();
                    }

                    for (var i = 0; i < self.userData.settings.tags.length; i++) { // Check for tag with the same name
                        if ($tagInput.val() == self.userData.settings.tags[i]) {
                            findSameTag = true;
                        }
                    }

                    if (!findSameTag) {
                        $(".select2-no-results").text("Press enter for add new tag");
                        $(".select2-no-results").css("overflow-y", "hidden");
                        if (e.keyCode == 13) {

                            self.userData.settings.tags.push(e.target.value);
                            self.saveChanges();

                            var selected_values = $("#e9").val();
                            addNewTag(null);
                            var new_tag_id = $("#e9 option:first").val();
                            if (!selected_values) {
                                selected_values = [];
                                selected_values[0] = new_tag_id;
                            } else {
                                // selected_values = $("#e9").val();
                                selected_values[selected_values.length] = new_tag_id;
                            }
                            $("#e9").val(selected_values).trigger("change");
                        }
                    }
                }
            });
        }
    });

    notificationsListLinked();


    /* -------------------------------------------------------------------------------------------------------------------------------------------------------------- */
});

var availableTags = [
    "tag",
    "long-tag-long-tag"
];

function initTagAutocomplete(input) {

    var $input = input,
        $wrapper = $input.closest('.ll-ext-tags').find('.ll-ext-autocomplete-wrapper'),
        $scroll = $wrapper.find('.scrollbar-inner');

    $input.autocomplete({
        source: availableTags,
        appendTo: $scroll.find('.scroll-content'),
        open: function () {
            var $this = $(this),
                left = $this.position().left,
                top = $this.position().top + $this.height() + 5;

            $wrapper.show().css({
                left: left,
                top: top
            })
            $wrapper.find(".ui-autocomplete").css({
                left: 0,
                top: 0,
                width: '100%'
            });
            $scroll.scrollbar();
        },
        select: function (event, ui) {
            addTag($input, ui.item.value);
            resizeTagInput($input);
            return false;
        },
        close: function () {
            $wrapper.hide();
        }
    });
}
;

function checkPopupPosition() {
    if ($('[data-popup].active').length && $('.ll-ext-popup.active').length) {

        var item = $('[data-popup].active');
        var popup = $('.ll-ext-popup.active');


        var left = item.offset().left - $('.ll-ext-btn-wrapper').offset().left - (popup.outerWidth() - item.outerWidth()) / 2;

        left = (left + popup.outerWidth() < $('.ll-ext-btn-wrapper').width())
            ? left
            : $('.ll-ext-btn-wrapper').width() - popup.outerWidth();

        left = (left > 0)
            ? left
            : 0;

        popup.css('left', left);
    }

}
;

function showPopup(popup, item) {

    var left = item.offset().left - $('.ll-ext-btn-wrapper').offset().left - (popup.outerWidth() - item.outerWidth()) / 2;
    left = (left + popup.outerWidth() < $('.ll-ext-btn-wrapper').width())
        ? left
        : $('.ll-ext-btn-wrapper').width() - popup.outerWidth();

    left = (left > 0)
        ? left
        : 0;


    left += $('.ll-ext-btn-wrapper').offset().left;

    $('.ll-ext-popup').removeClass('active');

    popup.addClass('active');

    if (document.location.href.indexOf("sales") + 1) {
        popup.css('left', left);
        popup.css('top', $('.ll-ext-btn-wrapper').offset().top + 61);
    } else {
        popup.css('right', event.target.getBoundingClientRect().right);
    }

    if (popup.attr('id') != "notification-popup")
        popup.find('.scrollbar-inner').scrollbar();

    initRangeSlider(popup);
    if (popup.find('.ll-ext-tags-wrapper').length) {
        var input = popup.find('.ll-ext-tags-add input');
        initTagAutocomplete(input);
    }

    if (popup.find('.ll-ext-textarea-wrapper').length) {
        popup.find('.ll-ext-textarea-wrapper').resizable();
        popup.find('.ll-ext-textarea-wrapper textarea').addClass('textarea-scrollbar').scrollbar();
    }
}
;

function hidePopup(popup) {
    popup.removeClass('active');
}
;

function addTag(input, val) {
    var $this = input;
    $this.closest('.ll-ext-tags-add').before('<div class="ll-ext-tag">' + val + '<span></span></div>');
    $this.val('');

    $this.autocomplete("close");

    $this.closest('.scrollbar-inner').scrollTop($this.closest('.scroll-wrapper').height());
}
;

function resizeTagInput(input) {
    var $input = input,
        $helper = $input.closest('.ll-ext-tags-wrapper').find('.tag-input-helper'),
        maxWidth = $input.closest('.ll-ext-tags').width() - 10,
        val = $input.val(),
        escaped = val.replace(/&/g, '&amp;').replace(/\s/g, ' ').replace(/</g, '&lt;').replace(/>/g, '&gt;'),
        newWidth = 0;

    $helper.html(escaped);

    newWidth = $helper.width() + 20;

    newWidth = (newWidth <= maxWidth) ? newWidth : maxWidth;

    input.width(newWidth);
}
;

function initRangeSlider(slider) {

    var $slider = slider.find('.ll-ext-popup-slider'),
        start = parseInt($slider.attr('data-val')),
        min = parseInt($slider.attr('data-min')),
        max = parseInt($slider.attr('data-max')),
        $valueCont = $slider.siblings('.ll-ext-popup-slider-val'),
        $treat = $slider.closest('.ll-ext-popup').find('.ll-ext-popup-treat input');

    $slider.slider({
        range: "min",
        value: start,
        min: min,
        max: max,
        create: function (event, ui) {
            $valueCont.text(start);
            $treat.val(start + 1);
        },
        slide: function (event, ui) {
            $valueCont.text(ui.value);
            $treat.val(ui.value);
        },
        stop: function (event, ui) {
            $slider.attr('data-val', ui.value);
            $('body').trigger('slider-change', {settingName: $slider.attr('data-setting-name'), value: ui.value});
        }
    });
}
;

function getChar(event) {
    if (event.which == null) {
        if (event.keyCode < 32)
            return null;
        return String.fromCharCode(event.keyCode)
    }

    if (event.which != 0 && event.charCode != 0) {
        if (event.which < 32)
            return null;
        return String.fromCharCode(event.which)
    }

    return null;
}
;

function showTab($tabs, index) {
    $tabs.find('.ll-ext-tabs-labels a:eq(' + index + ')').addClass('active').siblings('a').removeClass('active');
    $tabs.find('.ll-ext-tabs-content:eq(' + index + ')').addClass('active').siblings('.ll-ext-tabs-content').removeClass('active');
    $tabs.find('.ll-ext-tabs-content:eq(' + index + ') .scrollbar-inner').scrollbar();
}
;

function insertAtCaret(txtarea, text) {
    var txtarea = txtarea[0],
        scrollPos = txtarea.scrollTop,
        strPos = 0,
        br = ((txtarea.selectionStart || txtarea.selectionStart == '0') ? "ff" : (document.selection ? "ie" : false));

    if ($(txtarea).val().length + text.length > $(txtarea).attr('maxlength'))
        return false;

    if (br == "ie") {
        txtarea.focus();
        var range = document.selection.createRange();
        range.moveStart('character', -txtarea.value.length);
        strPos = range.text.length;
    } else if (br == "ff") {
        strPos = txtarea.selectionStart;
    }

    var front = (txtarea.value).substring(0, strPos),
        back = (txtarea.value).substring(strPos, txtarea.value.length);

    txtarea.value = front + text + back;
    strPos = strPos + text.length;

    if (br == "ie") {
        txtarea.focus();
        var ieRange = document.selection.createRange();
        ieRange.moveStart('character', -txtarea.value.length);
        ieRange.moveStart('character', strPos);
        ieRange.moveEnd('character', 0);
        ieRange.select();
    } else if (br == "ff") {
        txtarea.selectionStart = strPos;
        txtarea.selectionEnd = strPos;
        txtarea.focus();
    }
    txtarea.scrollTop = scrollPos;
}
;
